<?php
// +-----------------------------------------------------------------------+
// |                                                                       |
// | THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS   |
// | "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT     |
// | LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR |
// | A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT  |
// | OWNER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, |
// | SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT      |
// | LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, |
// | DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY |
// | THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT   |
// | (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE |
// | OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.  |
// |                                                                       |
// +-----------------------------------------------------------------------+

if(is_readable("_include/config.php"))
    include "_include/config.php";
else
    include "config.php";

if(is_readable("_include/functions.php"))
    include "_include/functions.php";
else
    include "functions.php";

global $tmpdir, $utildir;
ini_set("session.save_path", $tmpdir);
session_start();

if ( stristr($_SERVER["HTTP_ACCEPT"],"application/xhtml+xml") ) {
    header("Content-type: application/xhtml+xml"); } else {
    header("Content-type: text/xml");
}
print("<?xml version=\"1.0\" encoding=\"UTF-8\"?>");
?>
<scopes>
<GET>

<?php
if (isset($_GET["task"]) && trim($_GET["task"]) == "check_pass"){
    $file=$_GET["file"];

    $status=shell_exec($utildir.'bin/unrar v -p- "'.$file.'" 2>&1');

    if (eregi("Encrypted", $status))
        $password="yes";
    else
        $password="no";
        
    print("<param name='file'>$file</param>");
    print("<param name='password'>$password</param>");
} 
else if (isset($_GET["task"]) && trim($_GET["task"]) == "check_binary"){
    if (file_exists($utildir.'bin/unrar') && is_executable($utildir.'bin/unrar'))
        $file_found="yes";
    else
        $file_found="no";
        
    print("<param name='file_found'>$file_found</param>");
} 
else if (isset($_GET["task"]) && trim($_GET["task"]) == "extract_rar"){
    $file=$_GET["file"];
    $dir=dirname($file);
    if(isset($_GET["password"]))
        $password="-p".$_GET["password"];
    else
        $password="";
    if(isset($_GET["keep_broken"]) && $_GET["keep_broken"] == 1)
        $kb="-kb";
    else
        $kb="";

    if(isset($_GET["extract_to_folder"]) && $_GET["extract_to_folder"] == "yes")
        $etf="-ad";
    else
        $etf="";

    if (file_exists($tmpdir."/.perror"))
        unlink($tmpdir."/.perror"); 

    $PID=shell_exec('cd '.$dir.';'.$utildir.'bin/unrar x -o+ -c- '.$etf.' '.$kb.' '.$password.' "'.$file.'" 1>&- 2>'.$tmpdir.'/.perror & echo $!');

    //if (eregi("Unexpected end of archive", $status))
    //    $error="Unexpected end of archive";
    //else if (eregi("CRC failed", $status))
    //    $error="Encrypted file: CRC failed";
    //else
    //$error="no";
        
    //print("<param name='file'>$file</param>");
    //print("<param name='error'>$error</param>");
    print("<param name='error'>$PID</param>");
}
else if (isset($_GET["task"]) && trim($_GET["task"]) == "extract_zip"){
    $file=$_GET["file"];
    $dir=dirname($file);
    if(isset($_GET["password"]))
        $password="-p".$_GET["password"];
    else
        $password="";
    if(isset($_GET["keep_broken"]) && $_GET["keep_broken"] == 1)
        $kb="-kb";
    else
        $kb="";

    if(isset($_GET["extract_to_folder"]) && $_GET["extract_to_folder"] == "yes")
        $etf="-ad";
    else
        $etf="";

    if (file_exists($tmpdir."/.perror"))
        unlink($tmpdir."/.perror"); 

    $PID=shell_exec('cd '.$dir.';'.$utildir.'bin/unrar x -o+ -c- '.$etf.' '.$kb.' '.$password.' "'.$file.'" 1>&- 2>'.$tmpdir.'/.perror & echo $!');

    print("<param name='error'>$PID</param>");
}
else if (isset($_GET["task"]) && trim($_GET["task"]) == "set_folder_type"){
    $file=$_GET["file"];
    $type=$_GET["type"];
    
    if (is_writable($file)) {
        if (file_exists($file.'.video'))
            unlink($file.'.video');
        if (file_exists($file.'.photo'))
            unlink($file.'.photo');
        if (file_exists($file.'.music'))
            unlink($file.'.music');
        if ($type == "music")
            touch($file.'.music');
        else if ($type == "video")
            touch($file.'.video');
        else if ($type == "photo")
            touch($file.'.photo');
        $error="No";
    }
    else
        $error="Access denied.";
    print("<param name='error'>$error</param>");
}
else if (isset($_GET["task"]) && trim($_GET["task"]) == "play_movie"){
    $file=$_GET["file"];
    $dir=dirname($file);
        
    print("<param name='error'>$error</param>");
}
else if (isset($_GET["task"]) && trim($_GET["task"]) == "check_pid"){
    $pid=$_GET["pid"];
        
    if (file_exists($tmpdir."/.perror") && filesize($tmpdir."/.perror") > 0) {
        $data=file_get_contents($tmpdir."/.perror");
        print("<param name='error'>error</param>");
        print("<param name='error'>$data</param>");
    }
    else {
        if (isPIDRunning($pid))
            print("<param name='error'>yes</param>");
        else 
            print("<param name='error'>no</param>");
    }
}
else if (isset($_GET["task"]) && trim($_GET["task"]) == "kill_pid"){
    $pid=$_GET["pid"];
        
    if (isPIDRunning($pid))
        killPid($pid);
    print("<param name='error'>yes</param>");
}
else if (isset($_GET["task"]) && trim($_GET["task"]) == "last_browsed"){
    $id=$_GET["id"];
    $f = @fopen($tmpdir."/.last_browsed", "w");
    if (!$f)
        return false;
    else {
        $rvalue = fwrite($f, $id."\n");
        fclose($f);
    }
    print("<param name='error'>yes</param>");
}
else if (isset($_GET["task"]) && trim($_GET["task"]) == "flip_drive"){
    $mode=$_GET["mode"];
    $id=$_GET["id"];
    if ($mode == 0)
        SetDriveParams($id,3,1);
    else if ($mode == 1)
        SetDriveParams($id,3,0);
    print("<param name='error'>yes</param>");
}
else if (isset($_GET["task"]) && trim($_GET["task"]) == "read_last_browsed"){
    $file = $tmpdir."/.last_browsed";
    if (file_exists($file)) {
        $data = file_get_contents($file);
    }
    else
        $data="";
    print("<param name='error'>".$data."</param>");
}
else if (isset($_GET["task"]) && trim($_GET["task"]) == "copy_file"){
    $destination=$_GET["destination"];
    $sources=explode(",",$_GET["source"]);
    $source="";
    foreach($sources as $file)
        $source=$source."\"".$file."\" ";
    if (file_exists($tmpdir."/.perror"))
        unlink($tmpdir."/.perror"); 

    $PID=shell_exec('cp -R '.$source.' "'.$destination.'" 1>&- 2>'.$tmpdir.'/.perror & echo $!');

    print("<param name='error'>$PID</param>");
}
else if (isset($_GET["task"]) && trim($_GET["task"]) == "move_file"){
    $destination=$_GET["destination"];
    $sources=explode(",",$_GET["source"]);
    $source="";
    foreach($sources as $file)
        $source=$source."\"".$file."\" ";

    if (file_exists($tmpdir."/.perror"))
        unlink($tmpdir."/.perror"); 

    $PID=shell_exec('mv '.$source.' "'.$destination.'" 1>&- 2>'.$tmpdir.'/.perror & echo $!');

    print("<param name='error'>$PID</param>");
}
else if (isset($_GET["task"]) && trim($_GET["task"]) == "set_permissions"){
    $file=$_GET["file"];
    $perms=$_GET["perms"];
    $recursive=$_GET["recursive"];
        
    if ($recursive == "yes")
        $status=shell_exec($utildir.'sbin/chmod -R '.$perms.' '.$file.' 2>&1');
    else
        $status=shell_exec($utildir.'sbin/chmod '.$perms.' '.$file.' 2>&1');
    print("<param name='error'>$status</param>");
}
?>

</GET>
</scopes>
