<?php
// +-----------------------------------------------------------------------+
// |                                                                       |
// | THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS   |
// | "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT     |
// | LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR |
// | A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT  |
// | OWNER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, |
// | SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT      |
// | LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, |
// | DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY |
// | THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT   |
// | (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE |
// | OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.  |
// |                                                                       |
// +-----------------------------------------------------------------------+

if(is_readable("_include/config.php"))
    include "_include/config.php";
else
    include "config.php";

if(is_readable("_include/functions.php"))
    include "_include/functions.php";
else
    include "functions.php";

global $errstr;
$message="";

//FUNCTION TO USE IN THE CODE LATER
global $tmpdir;
ini_set("session.save_path", $tmpdir);
session_start();
//XML HEADER

//include XML Header (as response will be in xml format)
if ( stristr($_SERVER["HTTP_ACCEPT"],"application/xhtml+xml") ) {
 		header("Content-type: application/xhtml+xml"); } else {
 		header("Content-type: text/xml");
}
echo("<?xml version=\"1.0\" encoding=\"UTF-8\"?>\n"); 
//PREPARE VALUES 

if(isset($_GET["!nativeeditor_status"]) && trim($_GET["!nativeeditor_status"])=="inserted"){
    //INSERT
    // Get values from post data
    $sno = $_GET["gr_id"];
    $name = $_GET["name"];
    $type = $_GET["type"];

    if ($type == "Text Document" || $type == "NFO Document")
        touch ($sno);
    else
        mkdir($sno, 0777);
    $newId = $_GET["gr_id"];
    $action = "insert";
} else if(isset($_GET["!nativeeditor_status"]) && $_GET["!nativeeditor_status"]=="delete_file"){
    //DELETE
    $sno = $_GET["gr_id"];
    $name = $_GET["name"];
    $type = $_GET["type"];

    if (file_exists($sno)) {
        if ($type != "Local Disk" && $type != "Network Drive" && 
		$type != "Removable Disk" && $type != "Ram Drive" && $type != "CD/DVD Drive") {
            if ($type == "File Folder")
                RecursiveDelete($sno, true);
            else
                unlink($sno);
        }
    }
    $newId = $_GET["gr_id"];
    $action = "delete";
} else if(isset($_GET["!nativeeditor_status"]) && $_GET["!nativeeditor_status"]=="deleted"){
    //DELETE
    $sno = $_GET["gr_id"];
    $name = $_GET["name"];
    $type = $_GET["type"];

    $newId = $_GET["gr_id"];
    $action = "delete";
} else if(isset($_GET["!nativeeditor_status"]) && $_GET["!nativeeditor_status"]=="shortcut"){
    //DELETE
    $source = $_GET["source"];
    $name = $_GET["name"];
    $type = $_GET["type"];
    $destination = $_GET["destination"];
    $newname = $_GET["newname"];

    shell_exec('cd $destination;ln -s "'.$source.'" "'.$newname.'" 1>&- 2>&- &');

    $newId = $_GET["gr_id"];
    $action = "update";
} else if(isset($_GET["!nativeeditor_status"]) && $_GET["!nativeeditor_status"]=="copy_file"){
    //DELETE
    $source = $_GET["source"];
    $name = $_GET["name"];
    $type = $_GET["type"];
    $destination = $_GET["destination"];
    $newname = $_GET["newname"];

    $PID=shell_exec('cp -R "'.$source.'" "'.$newname.'" 1>&- & echo $!');

    $newId = $_GET["gr_id"];
    $action = "return_pid";
    $message=$PID;
} else if(isset($_GET["!nativeeditor_status"]) && $_GET["!nativeeditor_status"]=="move_file"){
    //DELETE
    $source = $_GET["source"];
    $name = $_GET["name"];
    $type = $_GET["type"];
    $destination = $_GET["destination"];

    shell_exec('mv -f "'.$source.'" "'.$destination.'" 1>&- 2>&- &');

    $newId = $_GET["gr_id"];
    $action = "update";
} else if(isset($_GET["!nativeeditor_status"]) && $_GET["!nativeeditor_status"]=="paste"){
    //Download Links
    global $filename;

    // Get values from post data
    $sno = $_GET["gr_id"];
    $link = $_GET["link"];
    $outfilename = $_GET["filename"];
    $filesize = $_GET["filesize"];
    $completed = $_GET["completed"];
    $percent = $_GET["percent"];
    $elapsed = $_GET["elapsed"];
    $left = $_GET["left"];
    $speed = $_GET["speed"];
    $status = $_GET["status"];

    $arr = file($filename);

    // the line to delete is the line number minus 1, because arrays begin at zero
    $lineToReplace = $sno - 1;

    // Download file
    $newdata=downloadfile($link);

    if (is_array($newdata))
    {
        $link=$newdata[0];
        $outfilename=$newdata[1];
        $filesize=$newdata[2];
        $pid=$newdata[3];
        $start_time=$newdata[4];
        $end_time=$newdata[5];
        $status=$newdata[6];

        $arr["$lineToReplace"]=$link."|".$outfilename."|".$filesize."|".$pid."|".$start_time."|".$end_time."|".$status."\n";

        $fp = fopen($filename, 'w+');

        if($fp)
            // write the array to the file
            foreach($arr as $line) { fwrite($fp,$line); }

        fclose($fp);

        $action = "update";
        $newId = $_GET["gr_id"];
    }
    else
    {
        $pid=0;
        $newarr=explode('|',$arr["$lineToReplace"]);
        $newarr[6]="Failed\n";
        $new_arr=implode('|',$newarr);
        $arr["$lineToReplace"]=$new_arr;

        $fp = fopen($filename, 'w+');

        if($fp)
            // write the array to the file
            foreach($arr as $line) { fwrite($fp,$line); }

        fclose($fp);

        $errstr = $newdata;
        $newId = 0;
    }

////////////////////////////////////////////////////////////
} else if(isset($_GET["!nativeeditor_status"]) && $_GET["!nativeeditor_status"]=="rename"){
    $sno = $_GET["gr_id"];
    $name = $_GET["name"];
    $type = $_GET["type"];
    $location = dirname($sno);
    $oldname = basename($sno);

    if (is_writable($location))
    {
        rename($location.'/'.$oldname, $location.'/'.$name);
        if ($type == "File Folder")
            $newId = $location.'/'.$name.'/';
        else
            $newId = $location.'/'.$name;
        $action = "update";
    }
    else
    {
        $errstr = "rename: cannot rename ".$name.": Permission denied";
        $newId = 0;
    }
} else if(isset($_GET["!nativeeditor_status"]) && $_GET["!nativeeditor_status"]=="extract"){
    // Extract
    global $homedir;
    $sno = $_GET["gr_id"];
    $name = $_GET["name"];
    $type = $_GET["type"];
    $location = dirname($sno);
    $fname = basename($sno);

    if ($type == "GZIP Archive")
        shell_exec('cd '.$location.';gunzip '.$fname.' 1>&- 2>&- &');
    else if ($type == "ZIP Archive")
        shell_exec('cd '.$location.';unzip '.$fname.' 1>&- 2>&- &');
    else if ($type == "BZIP2 Archive")
        shell_exec('cd '.$location.';'.$homedir.'/_bin/bzip2 --decompress '.$fname.' 1>&- 2>&- &');
    else if ($type == "TAR Archive")
        shell_exec('cd '.$location.';tar xf '.$fname.' 1>&- 2>&- &');
    else if ($type == "HJSplit File")
        shell_exec('cd '.$location.';'.$homedir.'/_scripts/join.sh '.$fname.' 1>&- 2>&- &');

    $newId = $_GET["gr_id"];
    $action = "update";
} else if(isset($_GET["!nativeeditor_status"]) && $_GET["!nativeeditor_status"]=="extract_to_folder"){
    // Extract
    $sno = $_GET["gr_id"];
    $name = $_GET["name"];
    $type = $_GET["type"];
    $location = dirname($sno);
    $fname = basename($sno);
    $newdir = substr($fname, 0, strlen($fname)-4);

    if ($type == "ZIP Archive")
        shell_exec('cd '.$location.';unzip -d '.$newdir.' '.$fname.' 1>&- 2>&- &');
    else if ($type == "TAR Archive")
        shell_exec('cd '.$location.';mkdir '.$newdir.';cd '.$newdir.';tar xf ../'.$fname.' 1>&- 2>&- &');
    $newId = $_GET["gr_id"];
    $action = "update";
} else if(isset($_GET["!nativeeditor_status"]) && $_GET["!nativeeditor_status"]=="extract_w_passwd"){
    // Extract
    $sno = $_GET["gr_id"];
    $name = $_GET["name"];
    $type = $_GET["type"];
    $passwd = $_GET["passwd"];
    $keep_broken = $_GET["keep_broken"];
    $location = dirname($sno);
    $fname = basename($sno);
    $newdir = substr($fname, 0, strlen($fname)-4);

    if ($type == "ZIP Archive")
        shell_exec('cd '.$location.';unzip -P '.$passwd.' '.$fname.' 1>&- 2>&- &');
    else if ($type == "RAR Archive") {
        if ($keep_broken == 1)
            shell_exec('cd '.$location.';'.$homedir.'/_bin/unrar x -kb -p'.$passwd.' '.$fname.' 1>&- 2>&- &');
        else
            shell_exec('cd '.$location.';'.$homedir.'/_bin/unrar x -p'.$passwd.' '.$fname.' 1>&- 2>&- &');
    }
    $newId = $_GET["gr_id"];
    $action = "update";
}
?>
<!-- response xml -->
<data>
	<?php 
	if(strlen($newId)!=0){
		print('<action type="'.$action.'" sid="'.$_GET["gr_id"].'" tid="'.$newId.'">'.$message.'</action>');
	}else{
		print("<action type='error'>$errstr</action>");
	}
	?>
</data>
