<?php
// +-----------------------------------------------------------------------+
// |                                                                       |
// | THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS   |
// | "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT     |
// | LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR |
// | A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT  |
// | OWNER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, |
// | SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT      |
// | LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, |
// | DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY |
// | THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT   |
// | (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE |
// | OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.  |
// |                                                                       |
// +-----------------------------------------------------------------------+
global $tmpdir;
ini_set("session.save_path", $tmpdir);
session_start();
session_cache_limiter('nocache');
header("Cache-Control: no-cache, must-revalidate"); // HTTP/1.1
header("Expires: Sat, 26 Jul 1997 05:00:00 GMT"); // Date in the past
?>
<!-- dhtmlxcommon -->
<script src='_js/dhtmlx/dhtmlxcommon.js'></script>
<script src='_js/dhtmlx/dhtmlxcontainer.js'></script>

<!-- dhtmlxTabbar --> 
<link rel='stylesheet' type='text/css' href='_js/dhtmlx/dhtmlxtabbar.css'>
<script src='_js/dhtmlx/dhtmlxtabbar.js'></script>

<BODY onKeyPress="checkKey(event.which);" onLoad="document.propsform.cancel.focus();" style="overflow:hidden;background-color:#F0F8FF;">
<DIV id='a_tabbar' style='width:100%;height:88%;overflow:hidden;'></DIV>
<FORM name="propsform">
    <TABLE cellspacing=6 style="font-family:Tahoma;font-size:12px;" width="100%" style="margin-top:5px;margin-bottom:5px;">
    <TBODY>
    <TR><TD colspan="3" align="right" width="100%">
    <INPUT type="button" style="width:100px;" id="OK" value="OK" onclick="setproperties();">
    <INPUT type="button" style="width:100px;" id="cancel" value="Cancel" onclick="closeWindow();">
    <INPUT type="button" style="width:100px;" id="apply" value="Apply" onclick="closeWindow();" disabled>
    </TD></TR></TBODY></TABLE>
</FORM>
<SCRIPT TYPE="text/javascript">
var dhxTabbar, attributes;
dhxTabbar=new dhtmlXTabBar('a_tabbar','top');
dhxTabbar.setImagePath('_js/dhtmlx/imgs/');
dhxTabbar.setSkin(parent.defaultSkin);
dhxTabbar.addTab('General', 'General','100%');
dhxTabbar.setHrefMode('ajax-html');
<?php
if (isset($_GET["item"]))
    $item=$_GET["item"];
if (isset($_GET["type"]))
    $type=$_GET["type"];
if (isset($_GET["disk"]))
    $disk=$_GET["disk"];
if (isset($_GET["filesystem"]))
    $filesystem=$_GET["filesystem"];
else
    $filesystem='';

//$item=str_replace("&","%26",$item);
//$item=str_replace("+","%2B",$item);
echo "dhxTabbar.setContentHref('General','_include/getProperties.php?item=".$item."&type=".$type."&filesystem=".$filesystem."');\n";
?>
dhxTabbar.setTabActive('General');
<?php
if ($type == "File Folder") {
    echo "dhxTabbar.addTab('Customize', 'Customize','100%');\n";
    echo "dhxTabbar.setHrefMode('ajax-html');\n";
    echo "dhxTabbar.setContentHref('Customize','_include/setCustomize.php?item=".$item."');\n";
}
else if ($type == "Local Disk"){
    echo "dhxTabbar.addTab('Tools', 'Tools','100%');\n";
    echo "dhxTabbar.setHrefMode('ajax-html');\n";
    echo "dhxTabbar.setContentHref('Tools','_include/getDriveSettings.php?item=".$item."');\n";
    echo "document.propsform.OK.disabled = true;\n";
}
else {
    if ($type != "Removable Disk" && $type != "Network Drive" && $type != "Desktop" && 
        $type != "Ram Drive" && $type != "CD/DVD Drive"){
        echo "dhxTabbar.addTab('Summary', 'Summary','100%');\n";
        echo "dhxTabbar.setHrefMode('ajax-html');\n";
        echo "dhxTabbar.setContentHref('Summary','_include/getMediaInfo.php?item=".$item."&type=".$type."');\n";
    }
    else
        echo "document.propsform.OK.disabled = true;\n";
}
?>
//dhxTabbar.setOnTabContentLoaded(function(id){
//    switch (id){
//        case 'General':
//            document.getElementById('baseitem').focus();
//            break;
//    }
//});

function closeWindow(){
    parent.propWins.close();
}

function setproperties(){
    if (dhxTabbar.getActiveTab() == 'Customize') {
<?php
echo "var loader = dhtmlxAjax.getSync(\"_include/shellExec.php?task=set_folder_type&file=".$item."&type=\"+document.getElementById('folder_type').value);\n";
?>
}
else if (dhxTabbar.getActiveTab() == 'General') {
    if(document.getElementById('r_00').checked)
        perms=400;
    else
        perms=0;
    if(document.getElementById('r_01').checked)
        perms+=200;
    else
        perms+=0;
    if(document.getElementById('r_02').checked)
        perms+=100;
    else
        perms+=0;
    if(document.getElementById('r_10').checked)
        perms+=40;
    else
        perms+=0;
    if(document.getElementById('r_11').checked)
        perms+=20;
    else
        perms+=0;
    if(document.getElementById('r_12').checked)
        perms+=10;
    else
        perms+=0;
    if(document.getElementById('r_20').checked)
        perms+=4;
    else
        perms+=0;
    if(document.getElementById('r_21').checked)
        perms+=2;
    else
        perms+=0;
    if(document.getElementById('r_22').checked)
        perms+=1;
    else
        perms+=0;
    if(document.getElementById('recursive') != null){
        if(document.getElementById('recursive').checked)
            rec="yes";
        else
            rec="no";
    }else{
        rec="no";
    }
<?php
echo "var loader = dhtmlxAjax.getSync(\"_include/shellExec.php?task=set_permissions&file=".$item."&perms=\"+perms+\"&recursive=\"+rec);\n";
?>
}
    closeWindow();
}

function submitenter(myfield,e) {
    var keycode;
    if (window.event) keycode = window.event.keyCode;
    else if (e) keycode = e.which;
    else return true;
    if (keycode == 13) {
        setproperties();
        return false;
    }
    else if (keycode == 27) {
        closeWindow();
        return false;
    }
    else
        return true;
}

function checkKey(key){
    if (! key) key = event.keyCode;
    if (key == 27)
    closeWindow();
}

function viewSMART() {
    wins=parent.dhxSmartWins.createWindow('w3',10,10,850,480);
    parent.dhxSmartWins.setSkin(parent.defaultSkin);
    parent.dhxSmartWins.setImagePath("_js/dhtmlx/imgs/");
    wins.setText('Hard Disk S.M.A.R.T Properties'); 
    wins.center(); 
    wins.denyResize(); 
    wins.denyPark(); 
    wins.button('park').hide(); 
    wins.button('minmax1').hide(); 
    wins.setModal(true); 
<?php
echo "wins.attachURL('_include/viewSmart.php?disk=".$disk."'); \n";
?>
}
</SCRIPT>
</body>
