<?php
// +-----------------------------------------------------------------------+
// |                                                                       |
// | THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS   |
// | "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT     |
// | LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR |
// | A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT  |
// | OWNER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, |
// | SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT      |
// | LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, |
// | DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY |
// | THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT   |
// | (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE |
// | OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.  |
// |                                                                       |
// +-----------------------------------------------------------------------+
if(is_readable("_include/config.php"))
    include "_include/config.php";
else
    include "config.php";

if(is_readable("_include/functions.php"))
    include "_include/functions.php";
else
    include "functions.php";

if(isset($_GET["disk"]))
    $disk=$_GET["disk"];
else
    $disk="/";

$file = tempnam($tmpdir,'smartctl.');
shell_exec($utildir."sbin/smartctl -iH ".$disk." > ".$file);
$arr = file($file);
$output = array_keys(preg_grep('/Device Model:/',$arr));
$device_model = explode(":", $arr[$output[0]]);
unlink($file);
?>
<!-- dhtmlxcommon -->
<script src='_js/dhtmlx/dhtmlxcommon.js'></script>
<script src='_js/dhtmlx/dhtmlxcontainer.js'></script>

<!-- dhtmlxGrid -->
<link rel='stylesheet' type='text/css' href='_js/dhtmlx/dhtmlxgrid.css'>
<link rel="stylesheet" type="text/css" href="_js/dhtmlx/skins/dhtmlxgrid_dhx_skyblue.css">
<script src='_js/dhtmlx/dhtmlxgrid.js'></script>
<script src='_js/dhtmlx/dhtmlxgridcell.js'></script>

<!-- dhtmlxTabbar --> 
<link rel='stylesheet' type='text/css' href='_js/dhtmlx/dhtmlxtabbar.css'>
<script src='_js/dhtmlx/dhtmlxtabbar.js'></script>

<BODY onKeyPress="checkKey(event.which);" onLoad="document.propsform.cancel.focus();" style="overflow:hidden;background-color:#F0F8FF;">
<table cellspacing=8 style='font-family:Tahoma;font-size:12px;margin-top:8px;margin-bottom:0px;' >
<?php
echo "<tr><td align='right'><b>Device:</b>$disk</td>\n";
echo "<td align='right'><b>Model:</b>$device_model[1]</td></tr>\n";
?>
</table>
<div id='a_tabbar' style='width:100%;height:82%;overflow:hidden;'></div>
<table cellspacing=5 style="font-family:Tahoma;font-size:12px;" width="100%" style="margin-top:5px;margin-bottom:0px;">
<tr><td colspan="3" align="right" width="100%">
<input type="button" style="width:100;" value="OK" onclick="closeWindow();">
<input type="button" style="width:100;" value="Cancel" onclick="closeWindow();">
<input type="button" style="width:100;" value="Apply" onclick="closeWindow();" disabled>
</td></tr>
</table>

<script>
var dhxTabbar, dhxAttribGrid;
dhxTabbar=new dhtmlXTabBar('a_tabbar','top');
dhxTabbar.setImagePath('_js/dhtmlx/imgs/');
dhxTabbar.setSkin(parent.defaultSkin);
dhxTabbar.addTab('a1', 'Identity','100%');
dhxTabbar.addTab('a2', 'Attributes','100%');
// Grid
dhxAttribGrid= dhxTabbar.cells("a2").attachGrid();
dhxAttribGrid.setImagePath('_js/dhtmlx/imgs/');
dhxAttribGrid.setHeader('ID,Name,Failed,Norm-ed value,Worst,Threshold,Raw value,Type,Updated,Flag');
dhxAttribGrid.setColTypes('ro,ro,ro,ro,ro,ro,ro,ro,ro,ro');
dhxAttribGrid.setInitWidthsP('5,20,8,10,8,10,10,10,10,*');
dhxAttribGrid.setColAlign('left,left,left,left,left,left,left,left,left,left');
dhxAttribGrid.setColSorting('int,str,str,int,int,int,int,str,str,str');
dhxAttribGrid.setSkin(parent.defaultSkin);
dhxAttribGrid.loadXML('_include/getSmart.php?id=attributes&device=<?php echo $disk ?>');
dhxAttribGrid.init();
dhxAttribGrid.setSortImgState(true,0,'asc');
dhxTabbar.setHrefMode('ajax-html');
dhxTabbar.setContentHref('a1','_include/getSmart.php?id=identity&device=<?php echo $disk ?>');
//dhxTabbar.setContent('a2','attributes');
dhxTabbar.setTabActive('a1');
function closeWindow(){
    parent.dhxSmartWins.window("w3").close();
}
function checkKey(key){
    if (! key) key = event.keyCode;
    if (key == 27)
        closeWindow();
}
</script>
</BODY>
