<?php
// +-----------------------------------------------------------------------+
// |                                                                       |
// | THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS   |
// | "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT     |
// | LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR |
// | A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT  |
// | OWNER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, |
// | SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT      |
// | LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, |
// | DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY |
// | THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT   |
// | (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE |
// | OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.  |
// |                                                                       |
// +-----------------------------------------------------------------------+

//include db connection settings
if(is_readable("_include/config.php"))
    include "_include/config.php";
else
    include "config.php";

if(is_readable("_include/functions.php"))
    include "_include/functions.php";
else
    include "functions.php";
?>
.even_row{
background-color:#22FF44;
}
.odd_row{
background-color:#41964e;
}
<script> 
    var dhxFoldersA, dhxFoldersB, dhxFMGrid, dhxFMLayout, dhxFMTree, dhxMenuBar, dhxFMStatusbar;
    var dhxGridDProcessor, dhxToolbarB, srt_clmn=1, srt_ord="asc", dhxWins, wins;
    var dhxSmartWins, intervalID, dhxTreeMenu, dhxEmptyGridMenu, dhxGridMenu;
    var mode="", add_to_history=1, password="", keep_broken=1;
    var extract_to_folder="no", dhxTreeDProcessor;
    var view_type, ctrl_pressed,  width, height=0, dhxWinProps, propWins, dhxWinView;
    var home_dir="<?php echo $GLOBALS["homedir"] ?>", sourceId, dhxConfirmWin,confirmwins;
    var last_selected="popcornhour", prev_treenodeId, viewWins, dhxErrorWin, errorwins;
    var dhxTabbar, ok_pressed=false, dhxProgressWin,progresswins;
    var objects=0, first_load=0;
    var Clipboard_Content=new Array();
    var defaultSkin="dhx_skyblue";

    dhxFMLayout = new dhtmlXLayoutObject(document.body, "2U", defaultSkin);
    dhxFMLayout.cells("a").setText("Folders");
    dhxFMLayout.cells("b").hideHeader();
    dhxFMLayout.cells("a").setWidth(250);

    dhxSmartWins = new dhtmlXWindows();
    dhxProgressWin = new dhtmlXWindows();
    dhxErrorWin = new dhtmlXWindows();
    dhxConfirmWin = new dhtmlXWindows();
    dhxSmartWins.setImagePath("_js/dhtmlx/imgs/");

    // Tree
    dhxFMTree = dhxFMLayout.cells("a").attachTree(); 
    dhxFMTree.setImagePath("_img/tree/");
    dhxFMTree.enableDragAndDrop(true,true);
    dhxFMTree.enableImageDrag(true);
    //dhxFMTree.setDragBehavior("complex");
    dhxFMTree.setEscapingMode("utf8");

    //dhxFMTree.loadXML("_include/getDirTree.php");
    dhxFMTree.loadXML("_include/getDirTree.php", function(){
        //dhxFMTree.loadOpenStates();
    });

    dhxFMTree.setXMLAutoLoading("_include/getDirTree.php");
    dhxFMTree.setOnClickHandler(selectTreeNode);
    dhxFMTree.enableItemEditor(true);
    dhxFMTree.enableKeyboardNavigation(true);
    dhxFMTree.attachEvent("onEdit",editTreeNode);

    dhxFMTree.attachEvent("onXLE",function() {
        //dhxFMTree.openItemsDynamic('/opt/sybhttpd/localhost.drives/SATA_DISK/',true);
    });

    dhxFMTree.attachEvent("onBeforeDrag",function(sourceID) {
        if (dhxFMTree.getUserData(sourceID,"is_writable") == 1) 
                return true;
        else
            return false;
    });

    dhxFMTree.attachEvent("onDragIn",function(sourceID, targetID, sourceGrid, targetGrid){
    /*    if (targetGrid == dhxFMTree) {
            if (targetID != undefined) {
                if (dhxFMTree.getOpenState(targetID) == 0) {
                    window.setTimeout('dhxFMTree.openItem("'+targetID+'")',1000);
                }
            }
        }
*/
        if(dhxFMTree.getUserData(targetID,"is_writable") == 1)
            return true;
        else
            return false;

    });

    dhxFMTree.attachEvent("onDrop",function(sourceID, targetID, targetID_copy, sourceGrid, targetGrid){
        if (sourceGrid == dhxFMGrid) {
            var ids=dhxFMGrid.getSelectedRowId().split(',');
            for (var i=0; i<ids.length; i++) {
                rowId=dhxFMGrid.getRowId(0);
                dhxFMGrid.setUserData(rowId,"!nativeeditor_status","move_file");
                dhxFMGrid.setUserData(rowId,"source",ids[i]);
                dhxFMGrid.setUserData(rowId,"destination",targetID);
                dhxGridDProcessor.sendData(rowId);
            }
            dhxFMTree.setUserData(targetID,"!nativeeditor_status","updated");
            dhxTreeDProcessor.sendData(targetID);
            dhxFMTree.setUserData(dirname(sourceID),"!nativeeditor_status","updated");
            dhxTreeDProcessor.sendData(dirname(sourceID));
            selid=dhxFMTree.getSelectedItemId();
            dhxFMTree.setUserData(selid,"!nativeeditor_status","updated");
            dhxTreeDProcessor.sendData(selid);
            dhxFMTree.deleteItem(sourceID);
        }
        return true;
    });

    dhxTreeMenu = new dhtmlXMenuObject();
    dhxTreeMenu.setIconsPath("_js/dhtmlx/imgs/");
    dhxTreeMenu.renderAsContextMenu();
    dhxTreeMenu.setOpenMode("web");
    dhxTreeMenu.setWebModeTimeout();
    dhxTreeMenu.loadXML("_data/contextTree.xml", function(){
        dhxTreeMenu.idPull[dhxTreeMenu.idPrefix+"expand"].style.fontWeight = 'bold';
        dhxTreeMenu.idPull[dhxTreeMenu.idPrefix+"collapse"].style.fontWeight = 'bold';
    <?php
        global $datadir;
        $drive_array = file($datadir."/drive_params");
        $cnt=0;
        foreach($drive_array as $drive_params) {
            $drive_mount = explode("|",$drive_params);
            if ($drive_mount[2] == "")
                $drive_name=$drive_mount[0]." on ".$drive_mount[1];
            else
                $drive_name=$drive_mount[2];
            print("dhxTreeMenu.addCheckbox('child', 'show', ".$cnt++.", '".$drive_mount[1]."', 
                   '".$drive_name."', !$drive_mount[3], false);\n");
        }
    ?>
    });

    dhxFMTree.enableContextMenu(dhxTreeMenu);
    dhxFMTree.attachEvent("onBeforeContextMenu",onTreeRightClick);

    dhxMenuBar = dhxFMLayout.attachMenu();
    dhxMenuBar.setOpenMode("win");
    dhxMenuBar.setIconsPath("_js/dhtmlx/imgs/");
    dhxMenuBar.loadXML("_data/menubar.xml");

    dhxGridMenu = new dhtmlXMenuObject();
    dhxGridMenu.setIconsPath("_js/dhtmlx/imgs/");
    dhxGridMenu.renderAsContextMenu();
    dhxGridMenu.setOpenMode("web");
    dhxGridMenu.setWebModeTimeout();
    dhxGridMenu.loadXML("_data/context.xml", disableMenuB);

    function disableMenuB() {
        dhxGridMenu.hideItem("zip");
        dhxGridMenu.hideItem("rar");
        dhxGridMenu.hideItem("bz2");
        dhxGridMenu.hideItem("gz");
        dhxGridMenu.hideItem("hj");
        dhxGridMenu.hideItem("tar");
        dhxGridMenu.hideItem("explore");
        dhxGridMenu.hideItem("view");
        dhxGridMenu.hideItem("play");
        dhxGridMenu.hideItem("edit");
        dhxGridMenu.hideItem("save");
        dhxGridMenu.hideItem("rename");
        dhxGridMenu.hideItem("sep02");
        dhxGridMenu.idPull[dhxGridMenu.idPrefix+"explore"].style.fontWeight = 'bold';
        dhxGridMenu.idPull[dhxGridMenu.idPrefix+"view"].style.fontWeight = 'bold';
        dhxGridMenu.idPull[dhxGridMenu.idPrefix+"play"].style.fontWeight = 'bold';
    }

    dhxEmptyGridMenu = new dhtmlXMenuObject();
    dhxEmptyGridMenu.setIconsPath("_js/dhtmlx/imgs/");
    dhxEmptyGridMenu.renderAsContextMenu();
    dhxEmptyGridMenu.setOpenMode("web");
    dhxEmptyGridMenu.setWebModeTimeout();
    dhxEmptyGridMenu.loadXML("_data/contextRC.xml");
    dhxEmptyGridMenu.attachEvent("onBeforeContextMenu", function(zoneId) {
        selid=dhxFMTree.getSelectedItemId();
        dhxFMGrid.clearSelection();
        if (selid == "popcornhour") {
            dhxEmptyGridMenu.hideItem("sep04");
            dhxEmptyGridMenu.hideItem("new");
        }
        else {
            dhxEmptyGridMenu.showItem("sep04");
            dhxEmptyGridMenu.showItem("new");
        }
        if(Clipboard_Content.length != 0) {
            if (selid != "popcornhour") {
                var data=Clipboard_Content.split("\n");
                if (data[0] == "Cut")
                    mode="cut";
                else if (data[0] == "Copy")
                    mode="copy";
                else 
                    mode="";

                if (mode == "cut"){
                    dhxEmptyGridMenu.setItemEnabled("paste");
                    dhxEmptyGridMenu.setItemDisabled("pasteshort");
                }
                else if (mode == "copy"){
                    dhxEmptyGridMenu.setItemEnabled("paste");
                    dhxEmptyGridMenu.setItemEnabled("pasteshort");
                }
                else {
                    dhxEmptyGridMenu.setItemDisabled("paste");
                    dhxEmptyGridMenu.setItemDisabled("pasteshort");
                }
            }
            else {
                dhxEmptyGridMenu.setItemDisabled("paste");
                dhxEmptyGridMenu.setItemDisabled("pasteshort");
            }
        }
        return true;
    });

Array.prototype.intersect =
  function() {
    if (!arguments.length)
      return [];
    var a1 = this;
    var a = a2 = null;
    var n = 0;
    while(n < arguments.length) {
      a = [];
      a2 = arguments[n];
      var l = a1.length;
      var l2 = a2.length;
      for(var i=0; i<l; i++) {
        for(var j=0; j<l2; j++) {
          if (a1[i] === a2[j])
            a.push(a1[i]);
        }
      }
      a1 = a;
      n++;
    }
    return a.unique();
  };

Array.prototype.unique =
  function() {
    var a = [];
    var l = this.length;
    for(var i=0; i<l; i++) {
      for(var j=i+1; j<l; j++) {
        // If this[i] is found later in the array
        if (this[i] === this[j])
          j = ++i;
      }
      a.push(this[i]);
    }
    return a;
  };

Array.prototype.diff =
  function() {
    var a1 = this;
    var a = a2 = null;
    var n = 0;
    while(n < arguments.length) {
      a = [];
      a2 = arguments[n];
      var l = a1.length;
      var l2 = a2.length;
      var diff = true;
      for(var i=0; i<l; i++) {
        for(var j=0; j<l2; j++) {
          if (a1[i] === a2[j]) {
            diff = false;
            break;
          }
        }
        diff ? a.push(a1[i]) : diff = true;
      }
      a1 = a;
      n++;
    }
    return a.unique();
  };

    ChangeView("details");

    dhxFMStatusbar = dhxFMLayout.attachStatusBar();

    dhxGridDProcessor = new dataProcessor("_include/updDirContent.php");
    dhxGridDProcessor.enableDataNames(true);
    dhxGridDProcessor.setUpdateMode("cell");
    dhxGridDProcessor.setTransactionMode("GET");
    dhxGridDProcessor.enableDebug(false);
    dhxGridDProcessor.defineAction("return_pid", function(node) {
        showProgress("Copying...","Copying files...",node.firstChild.data);
    });

    dhxGridDProcessor.setOnAfterUpdate(function(rowId,command,newId){
        if (dhxGridDProcessor.getSyncState())
        {
            if(dhxFMGrid.doesRowExist(rowId))
                dhxFMGrid.setRowId(dhxFMGrid.getRowIndex(rowId),newId);
            selid=dhxFMTree.getSelectedItemId();
            //dhxFMTree.smartRefreshItem(selid, "_include/getDirTree.php");
            dhxFMTree.smartRefreshItem(selid, "_include/getDirTree.php");
            dhxFMGrid.updateFromXML("_include/getDirContent.php?dir="+selid.replace(/&/g,"%26").replace(/\+/g,"%2B"), true, true);
            if(dhxFMGrid.doesRowExist(rowId))
                dhxFMGrid.selectRowById(newId, false, true,true);
            //dhxFMTree.openItem(selid, true);
        }
    });
    dhxTreeDProcessor = new dataProcessor("_include/updDirTree.php");
    dhxTreeDProcessor.enableDataNames(true);
    dhxTreeDProcessor.setUpdateMode("cell");
    dhxTreeDProcessor.setTransactionMode("GET");
    dhxTreeDProcessor.enableDebug(false);
    dhxTreeDProcessor.setOnAfterUpdate(function(rowId,command,newId){
        if (dhxTreeDProcessor.getSyncState())
        {
            //dhxFMTree.selectItem(newId, true);
            selid=dhxFMTree.getSelectedItemId();
            if(dhxFMTree.getIndexById(newId) != null)
                dhxFMTree.smartRefreshItem(newId, "_include/getDirTree.php");
            dhxFMGrid.clearAll();
            dhxFMGrid.updateFromXML("_include/getDirContent.php?dir="+selid.replace(/&/g,"%26").replace(/\+/g,"%2B"), true, true);
        }
    });

    dhxGridDProcessor.defineAction("error",onError);
    dhxGridDProcessor.init(dhxFMGrid);
    dhxTreeDProcessor.init(dhxFMTree);

    function pausecomp(millis) {
        var date = new Date();
        var curDate = null;

        do { curDate = new Date(); } 
        while(curDate-date < millis);
    } 

    function onError(node){
        //alert(node.firstChild.nodeName);    // error
        showError("Error","Error while processing data",node.firstChild.nodeValue,"error");    // Details
        //dhxGrid.setRowTextStyle(rowId,"background-color: red;");
        //dhxTree.selectItem("alldownloads", true);
        return false;
    }

    function editTreeNode(stage,objId,treeObj,value){
        is_internal=dhxFMTree.getUserData(objId,"is_internal");
        if (dhxFMTree.getUserData(dhxFMTree.getParentId(objId),"is_writable") == 1 ||
            (dhxFMTree.getParentId(objId) == 'popcornhour' && is_internal==0)) {
            if(stage==0){
                oldVal = value;
                return true;
            }else if(stage==2 ){
                newVal = value;
                return true;
            }else if(stage==3 ){
                if (newVal != oldVal) {
                    dhxFMTree.setUserData(objId,"!nativeeditor_status","rename");
                    dhxTreeDProcessor.sendData(objId);
                    return true;
                }
                else
                    return false;
            }
        }
        else
            return false;
    }

    function doOnCellEdit(stage,rowId,cellInd,newVal,oldVal){
        selid=dhxFMTree.getSelectedItemId();
        if (dhxFMTree.getUserData(selid,"is_writable") == 1)
        {
            if(stage==0){
                return true;
            }else if(stage==1 && dhxFMGrid.editor && dhxFMGrid.editor.obj){
                dhxFMGrid.editor.obj.select(); /* grid.editor.obj is the input object*/
                return true;
            }else if(stage==2){
                if (oldVal != newVal){
                    dhxFMGrid.setUserData(rowId,"!nativeeditor_status","rename");
                    dhxGridDProcessor.sendData(rowId);
                }
                return true;
            }
        }
        else
        {
            name = dhxFMGrid.cells(rowId,1).getValue();
            showError("Error Renaming File or Folder", "Cannot rename "+name+": Access is denied.","Make sure the directory "+dhxFMTree.getSelectedItemText()+" is not write-protected.","error");    // Details
            return false;
        }
    }

    function createFolder(inputimg){
        selid=dhxFMTree.getSelectedItemId();
        if (dhxFMTree.getUserData(selid,"is_writable") == 1)
        {
            num=dhxFMGrid.getRowsNum();
            var currentTime = new Date()
            datenow=currentTime.getFullYear()+'/'+currentTime.getMonth()+'/'+
                    currentTime.getDate()+' '+currentTime.getHours()+':'+
                            currentTime.getMinutes()+':'+currentTime.getSeconds();
            dhxFMGrid.setUserData(dhxFMGrid.getRowId(0),"type","dir");
            fid=1;
            folder_exists=0;
            while (folder_exists != -1)
            {
                if (fid==1)
                    new_folder="New Folder";
                else
                    new_folder="New Folder ("+fid+")";
                sid=selid+new_folder+"/";
                folder_exists=dhxFMGrid.getRowIndex(sid);
                fid++;
            }
            dhxFMGrid.addRow(sid, "_js/dhtmlx/imgs/"+inputimg+","+new_folder+",,File Folder,"+datenow);
            dhxFMGrid.selectCell(num, 1);
            dhxFMGrid.editCell();
            //dhxFMTree.selectItem(selid, true);
        }
        else
            showError("Unable to create folder","Unable to create the folder 'New Folder'","Access is denied.","error");
    }

    function createFile(inputfile, inputimg, ext){
        selid=dhxFMTree.getSelectedItemId();
        if (dhxFMTree.getUserData(selid,"is_writable") == 1)
        {
            num=dhxFMGrid.getRowsNum();
            var currentTime = new Date()
            datenow=currentTime.getFullYear()+'/'+currentTime.getMonth()+'/'+
                    currentTime.getDate()+' '+currentTime.getHours()+':'+
                            currentTime.getMinutes()+':'+currentTime.getSeconds();
            dhxFMGrid.setUserData(dhxFMGrid.getRowId(0),"type","file");
            fid=1;
            file_exists=0;
            while (file_exists != -1)
            {
                if (fid==1)
                    new_folder="New "+inputfile+"."+ext;
                else
                    new_folder="New "+inputfile+" ("+fid+")."+ext;
                sid=selid+new_folder;
                file_exists=dhxFMGrid.getRowIndex(sid);
                fid++;
            }
            dhxFMGrid.addRow(sid, "_js/dhtmlx/imgs/"+inputimg+","+new_folder+",0 KB,"+inputfile+","+datenow);
            dhxFMGrid.selectCell(num, 1);
            dhxFMGrid.editCell();
        }
        else
            showError("Unable to create file","Unable to create the file 'New "+inputfile+"'","Access is denied.","error");
    }

    dhxEmptyGridMenu.attachEvent("onClick", function(id, zoneId){
        switch(id){
            case 'refresh':
                //dhxFMGrid.clearAll();
                selid=dhxFMTree.getSelectedItemId();
                if (selid != "popcornhour")
                {
                    dhxFMTree.smartRefreshItem(selid, "_include/getDirTree.php");
                    dhxFMGrid.updateFromXML("_include/getDirContent.php?dir="+selid.replace(/&/g,"%26").replace(/\+/g,"%2B"), true, true);
                }
                break;
            case 'folder':
                var inputimg = dhxEmptyGridMenu.getItemImage(id);
                createFolder(basename(inputimg[0]));
                break;
            case 'txt':
            case 'nfo':
                var inputfile = dhxEmptyGridMenu.getItemText(id);
                var inputimg = dhxEmptyGridMenu.getItemImage(id);
                createFile(inputfile, basename(inputimg[0]), id);
                break;
            case 'paste':
                PasteData();
                break;
            case 'pasteshort':
                PasteShortCut();
                break;
            case 'properties':
                showProperties("tree");
                break;
        }
    }); 

    dhxTreeMenu.attachEvent("onClick", function(id, zoneId){
        treeId = dhxFMTree.getSelectedItemId();
        selected = dhxTreeMenu.getCheckboxState(id);
        switch(id){
            case 'expand':
                dhxFMTree.selectItem(treeId, true);
                break;
            case 'collapse':
                dhxFMTree.closeItem(treeId);
                break;
            case 'explore':
                dhxFMTree.selectItem(treeId, true);
                break;
            case 'refresh':
                dhxFMTree.smartRefreshItem(treeId, "_include/getDirTree.php");

                if (view_type == "details")
                    dhxFMGrid.updateFromXML("_include/getDirContent.php?dir="+treeId.replace(/&/g,"%26").replace(/\+/g,"%2B"), true, true);
                else if (view_type == "icons") {
                    dhxFoldersB.clearAll();
                    dhxFoldersB.loadXML("_include/getDirContent.php?type=icons&dir="+treeId, "_js/dhtmlx/types/ficon.xsl");
                }
                else if (view_type == "tiles"){
                    dhxFoldersA.clearAll();
                    dhxFoldersA.loadXML("_include/getDirContent.php?type=icons&dir="+treeId, "_js/dhtmlx/types/ftiles.xsl");
                }

                if ((prev_treenodeId) && prev_treenodeId != treeId);
                    dhxFMTree.selectItem(prev_treenodeId);
                break;
            case 'rename':
                dhxFMTree.editItem(treeId);
                break;
            case 'hide':
                flipSelectedDrive(treeId, false);
                break;
            case 'properties':
                showProperties("tree");
                if ((prev_treenodeId) && prev_treenodeId != treeId);
                    dhxFMTree.selectItem(prev_treenodeId);
                break;
            <?php
                global $datadir;
                $drive_array = file($datadir."/drive_params");
                $cnt=0;
                foreach($drive_array as $drive_params) {
                    $drive_mount = explode("|",$drive_params);
                    print("case '".$drive_mount[1]."':\n");
                    print("flipSelectedDrive(id+'/', selected);\n");
                    print("break;\n");
                }
            ?>
        }
    }); 

    dhxGridMenu.attachEvent("onClick", function(id, zoneId){
        switch(id){
            case 'explore':
                if(dhxFMGrid.getSelectedId())
                    showFileContent(dhxFMGrid.getSelectedId());
                break;
            case 'save':
                if(dhxFMGrid.getSelectedId()) {
                    id = dhxFMGrid.getSelectedId();
                    document.location="_include/getFile.php?file="+id;
                }
                break;
            case 'view':
                if(dhxFMGrid.getSelectedId()) {
                    id = dhxFMGrid.getSelectedId();
                    viewFile(id);
                }
                break;
            case 'play':
                playMovie();
                break;
            case 'rar1':
            case 'rar2':
                selid=dhxFMTree.getSelectedItemId();
                var ids=dhxFMGrid.getSelectedId().split(',');
                if (dhxFMTree.getUserData(selid,"is_writable") == 1)
                {
                    if (id == "rar2")
                        extract_to_folder="yes";
                    else
                        extract_to_folder="no";
                    var loader = dhtmlxAjax.getSync("_include/shellExec.php?task=check_binary");
                    if (loader.xmlDoc.responseXML!=null) {
                        var params = loader.doXPath("//param");
                        file_found=params[0].firstChild.nodeValue;
                        if (file_found == "no") {
                            showError("Unrar binary not found","Unrar binary not found","Make sure you have installed the utils package from CSI.","error");
                        }
                    }
                    var loader = dhtmlxAjax.getSync("_include/shellExec.php?task=check_pass&file="+ids[0]);
                    if (loader.xmlDoc.responseXML!=null) {
                        var params = loader.doXPath("//param");
                        passwd=params[1].firstChild.nodeValue;
                        if (passwd == "yes") {
                            extractWPassword();
                            return true; 
                        }
                        else {
                            dhtmlxAjax.get("_include/shellExec.php?task=extract_rar&file="+ids[0]+"&extract_to_folder="+extract_to_folder,
                                function(loader){
                                if(loader.xmlDoc.responseXML!=null) {
                                    var params = loader.doXPath("//param");
                                    showProgress("Extracting...","Extracting files...",params[0].firstChild.nodeValue);
                                }
                            });
                        }
                    }
                }
                else
                {
                    showError("Error Extracting Files", "Cannot extract/decompress "+basename(ids[0])+": Access is denied.","Make sure the directory "+dhxFMTree.getSelectedItemText()+" is not write-protected.","error");
                }
                break;
            case 'zip1':
            case 'hj1':
            case 'gz1':
            case 'tar1':
                selid=dhxFMTree.getSelectedItemId();
                var ids=dhxFMGrid.getSelectedId().split(',');
                if (dhxFMTree.getUserData(selid,"is_writable") == 1)
                {
                    dhxFMGrid.setUserData(ids[0],"!nativeeditor_status","extract");
                    dhxGridDProcessor.sendData(ids[0]);
                    return true; 
                }
                else
                {
                    showError("Error Extracting Files", "Cannot extract/decompress "+basename(ids[0])+": Access is denied.","Make sure the directory "+dhxFMTree.getSelectedItemText()+" is not write-protected.","error");
                }
                break;
            case 'tar2':
            case 'zip2':
                selid=dhxFMTree.getSelectedItemId();
                var ids=dhxFMGrid.getSelectedId().split(',');
                if (dhxFMTree.getUserData(selid,"is_writable") == 1)
                {
                    dhxFMGrid.setUserData(ids[0],"!nativeeditor_status","extract_to_folder");
                    dhxGridDProcessor.sendData(ids[0]);
                    return true; 
                }
                else
                {
                    showError("Error Extracting Files", "Cannot extract/decompress "+basename(ids[0])+": Access is denied.","Make sure the directory "+dhxFMTree.getSelectedItemText()+" is not write-protected.","error");
                }
                break;
            case 'cut':
                CutData();
                break;
            case 'copy':
                CopyData();
                break;
            case 'pasteshort':
                CopyData();
                PasteShortCut();
                break;
            case 'delete':
                if(dhxFMGrid.getSelectedId())
                    deleteSelectedId();
                break;
            case 'rename':
                if(dhxFMGrid.getSelectedId())
                {
                    num=dhxFMGrid.getRowsNum();
                    dhxFMGrid.selectCell(num, 1);
                    dhxFMGrid.editCell();
                }
                break;
            case 'properties':
                showProperties("grid");
                break;
        }
    }); 
   
    function extractWPassword() {
        dhxWins = new dhtmlXWindows();
        dhxWins.setSkin(defaultSkin); 
        dhxWins.setImagePath("_js/dhtmlx/imgs/");
        wins=dhxWins.createWindow("w1",10,10,288,193);
        wins.setText("Enter Password");
        wins.center();
        wins.denyResize();
        wins.denyPark();
        wins.button("park").hide();
        wins.button("minmax1").hide();
        wins.setModal(true);
        wins.attachURL("_include/getPassword.php");

        dhxWins.attachEvent("onClose", function() {
            if (password != undefined) {
                if (keep_broken == false)
                    keep_broken=0;
                else
                    keep_broken=1;
                selid=dhxFMTree.getSelectedItemId();
                var ids=dhxFMGrid.getSelectedId().split(',');
                if (dhxFMTree.getUserData(selid,"is_writable") == 1)
                {
                    dhtmlxAjax.get("_include/shellExec.php?task=extract_rar&file="+ids[0]+"&password="+password+"&keep_broken="+keep_broken+"extract_to_folder="+extract_to_folder, function(loader){
                        if(loader.xmlDoc.responseXML!=null) {
                            var params = loader.doXPath("//param");
                            showProgress("Extracting...","Extracting files...",params[0].firstChild.nodeValue);
                        }
                    });
                    return true;
                }
                else
                {
                    showError("Error Extracting Files", "Cannot extract/decompress "+basename(ids[0])+": Access is denied.","Make sure the directory "+dhxFMTree.getSelectedItemText()+" is not write-protected.","error");
                }
            }
            return true;
        });
    }
   
    function showProperties(wtype) {
        var type, text;
        if (wtype == "grid") {
            id=dhxFMGrid.getSelectedRowId();
            type = dhxFMGrid.cells(id,3).getValue();
            text=dhxFMGrid.cells(id,1).getValue();
            disk='';
            filesystem='';
        }
        else if (wtype == "tree"){
            id=dhxFMTree.getSelectedItemId();
            type=dhxFMTree.getUserData(id,"type");
            text=dhxFMTree.getItemText(id);
            disk=dhxFMTree.getUserData(id,"disk_id");
            filesystem=dhxFMTree.getUserData(id,"filesystem");
        }

        dhxWinProps = new dhtmlXWindows();
        dhxWinProps.setSkin(defaultSkin); 
        dhxWinProps.setImagePath("_js/dhtmlx/imgs/");
        if (type == "File Folder") {
            propWins=dhxWinProps.createWindow("w2",10,10,480,600);
            propWins.setText(text+" Properties");
        }
        else {
            propWins=dhxWinProps.createWindow("w2",10,10,480,550);
            propWins.setText(text+" Properties");
        }
        propWins.center();
        propWins.denyResize();
        propWins.denyPark();
        propWins.button("park").hide();
        propWins.button("minmax1").hide();
        propWins.setModal(true);

        propWins.attachURL("_include/viewProperties.php?item="+id.replace(/&/g,"%26").replace(/\+/g,"%2B")+"&type="+type+"&disk="+disk+"&filesystem="+filesystem);

    }
   
    function viewFile(id) {
        type = dhxFMGrid.cells(id,3).getValue();
        dhxWinView = new dhtmlXWindows();
        dhxWinView.setSkin(defaultSkin); 
        dhxWinView.setImagePath("_js/dhtmlx/imgs/");
        if (type == "Text Document" || type == "PHP Script" || type == "SQL File" ||
		type == "PERL Script" || type == "HTML Page" || type == "Javascript File" ||
		type == "CSS File" || type == "CGI Script" || type == "C++ Header File" ||
		type == "C++ Source File" || type == "Java Source File"  || type == "PNG Image" ||
		type == "GIF Image") {
            viewWins=dhxWinView.createWindow("w2",10,10,880,535);
        }
        viewWins.setText("View - "+basename(id));
        viewWins.center();
        //viewWins.denyResize();
        //viewWins.denyPark();
        //viewWins.button("park").hide();
        //viewWins.button("minmax1").hide();
        //viewWins.setModal(true);

        viewWins.attachURL("_include/viewFile.php?file="+id);
    }

    function outputResponse(loader){
        if(loader.xmlDoc.responseXML!=null)
            alert(loader.doSerialization());
        else
            alert("Response contains no XML");
    }

    dhxMenuBar.attachEvent("onClick", function(id, zoneId){
        switch(id){
            case 'about':
                Sexy.info('<h1>File Manager</h1><em>for Networked Media Tank</em><br/><em>version <?php echo print_version(); ?></em><br/><p></p><p>Visit <a href=\'http://www.networkedmediatank.com/showthread.php?tid=17409\'>www.networkedmediatank.com</a> for more info.</p><br/><br/><br/><p>&copy; DHTMLX Ltd.</p><p>dhtmlxSuite 2008 GNU GPL license</p>');
                break;
            case 'refresh':
                selid=dhxFMTree.getSelectedItemId();
                if (view_type == "details"){
                    if (selid != "popcornhour") {
                        dhxFMTree.smartRefreshItem(selid, "_include/getDirTree.php");
                        dhxFMGrid.updateFromXML("_include/getDirContent.php?dir="+selid.replace(/&/g,"%26").replace(/\+/g,"%2B"), true, true);
                    }
                }
                else if (view_type == "icons") {
                    dhxFoldersB.clearAll();
                    dhxFoldersB.loadXML("_include/getDirContent.php?type=icons&dir="+selid, "_js/dhtmlx/types/ficon.xsl");
                }
                else if (view_type == "tiles"){
                    dhxFoldersA.clearAll();
                    dhxFoldersA.loadXML("_include/getDirContent.php?type=icons&dir="+selid, "_js/dhtmlx/types/ftiles.xsl");
                }
                break;
            case 'selectall':
                var num=dhxFMGrid.getRowsNum();
                selid=dhxFMTree.getSelectedItemId();
                if (selid == "popcornhour")
                    var start=0;
                else
                    var start=2;
                for (var i=start;i<num;i++) {
                    dhxFMGrid.selectRow(i, true, true);
                }
                break;
            case 'invert':
                var num=dhxFMGrid.getRowsNum();
                selid=dhxFMTree.getSelectedItemId();
                if (selid == "popcornhour")
                    var start=0;
                else
                    var start=2;
                if (dhxFMGrid.getSelectedRowId()){
                    var num_idx = new Array();
                    for (var i=start;i<num;i++)
                        num_idx.push(i);
                    var ids=dhxFMGrid.getSelectedRowId().split(",");
                    var ids_idx = new Array();
                    for (var j=0;j<ids.length;j++)
                        ids_idx.push(dhxFMGrid.getRowIndex(ids[j]));

                    num_idx=num_idx.diff(ids_idx);
                    dhxFMGrid.clearSelection();
                    for (var k=0;k<num_idx.length;k++)
                        dhxFMGrid.selectRow(num_idx[k], true, true);
                }
                else {
                    for (var i=start;i<num;i++) {
                        dhxFMGrid.selectRow(i, true, true);
                    }
                }
                break;
            case 'paste':
                PasteData();
                break;
            case 'pasteshort':
                PasteShortCut();
                break;
            case 'cut':
                CutData();
                break;
            case 'copy':
                CopyData();
                break;
            case 'folder':
                var inputimg = dhxMenuBar.getItemImage(id);
                createFolder(basename(inputimg[0]));
                break;
            case 'txt':
            case 'nfo':
                var inputfile = dhxMenuBar.getItemText(id);
                var inputimg = dhxMenuBar.getItemImage(id);
                createFile(inputfile, basename(inputimg[0]), id);
                break;
            case 'properties':
                showProperties("grid");
                break;
        }
    }); 

    dhxMenuBar.attachEvent("onRadioClick", function(group, idChecked, idClicked, zoneId){
        dhxMenuBar.hide();
        if (group == "arrange")
        {
            if (srt_ord == "asc")
                srt_ord="des";
            else
                srt_ord="asc";
            switch(idClicked){
                case 'name':
                    srt_clmn=1;
                    break;
                case 'size':
                    srt_clmn=2;
                    break;
                case 'type':
                    srt_clmn=3;
                    break;
                case 'modified':
                    srt_clmn=4;
                    break;
            }
            dhxFMGrid.sortRows(srt_clmn, "str", srt_ord);
            dhxFMGrid.setSortImgState(true,srt_clmn,srt_ord);
            return true;
        }
        else if (group == "view")
        {
            switch(idClicked){
                case 'tiles':
                    dhxMenuBar.setRadioChecked("views","tiles");
                    dhxEmptyGridMenu.setRadioChecked("views","tiles");
                    ChangeView("tiles");
                    break;
                case 'icons':
                    dhxMenuBar.setRadioChecked("views","icons");
                    dhxEmptyGridMenu.setRadioChecked("views","icons");
                    ChangeView("icons");
                    break;
                case 'details':
                    dhxMenuBar.setRadioChecked("views","details");
                    dhxEmptyGridMenu.setRadioChecked("views","details");
                    ChangeView("details");
                    break;
            }
            return true;
        }
    });

    dhxEmptyGridMenu.attachEvent("onRadioClick", function(group, idChecked, idClicked, zoneId){
        dhxEmptyGridMenu.hide();
        if (group == "arrange")
        {
            if (srt_ord == "asc")
                srt_ord="des";
            else
                srt_ord="asc";
            switch(idClicked){
                case 'name':
                    srt_clmn=1;
                    break;
                case 'size':
                    srt_clmn=2;
                    break;
                case 'type':
                    srt_clmn=3;
                    break;
                case 'modified':
                    srt_clmn=4;
                    break;
            }
            dhxFMGrid.sortRows(srt_clmn, "str", srt_ord);
            dhxFMGrid.setSortImgState(true,srt_clmn,srt_ord);
            return true;
        }
        else if (group == "view")
        {
            switch(idClicked){
                case 'tiles':
                    dhxMenuBar.setRadioChecked("views","tiles");
                    dhxEmptyGridMenu.setRadioChecked("views","tiles");
                    ChangeView("tiles");
                    break;
                case 'icons':
                    dhxMenuBar.setRadioChecked("views","icons");
                    dhxEmptyGridMenu.setRadioChecked("views","icons");
                    ChangeView("icons");
                    break;
                case 'details':
                    dhxMenuBar.setRadioChecked("views","details");
                    dhxEmptyGridMenu.setRadioChecked("views","details");
                    ChangeView("details");
                    break;
            }
            return true;
        }
    });


    // Toolbar
    dhxToolbarB = dhxFMLayout.attachToolbar();
    dhxToolbarB.setIconsPath("_img/toolbar/")
    dhxToolbarB.loadXML("_data/toolbarFM.xml", disableToolbarB);

    dhxFMTree.selectItem(home_dir, true);

    function doOnFMGridSelected(id){
        if(dhxFMGrid.getSelectedId()) {
            filetype = dhxFMGrid.cells(id,3).getValue();
            if (filetype != "Local Disk" && filetype != "Removable Disk" && filetype != "Network Drive" &&
                filetype != "Ram Drive" && filetype != "CD/DVD Drive") {
                dhxMenuBar.setItemEnabled("pasteshort");
                dhxMenuBar.setItemEnabled("copy");
                dhxMenuBar.setItemEnabled("cut");
            }
            else {
                dhxMenuBar.setItemDisabled("pasteshort");
                dhxMenuBar.setItemDisabled("copy");
                dhxMenuBar.setItemDisabled("cut");
            }
            var ids=dhxFMGrid.getSelectedRowId().split(",");
            if (ids.length == 1) {
                filetype = dhxFMGrid.cells(id,3).getValue();
                date_modified=dhxFMGrid.cells(id,4).getValue();
                size=dhxFMGrid.getUserData(id,"actual_size");
                free_space=dhxFMGrid.cells(id,7).getValue();
                total_size=dhxFMGrid.cells(id,8).getValue();

                if (size <1024 && size >=0)
                    size=size+" bytes";
                else if (size >=1024 && size <1048576)
                    size=roundNumber(size/1024,2)+" KB";
                else if (size >=1048576 && size <1073741824)
                    size=roundNumber(size/1024/1024,2)+" MB";
                else if (size >=1073741824)
                    size=roundNumber(size/1024/1024/1024,2)+" GB";
                if (filetype == "File Folder")
                    dhxFMStatusbar.setText("1 objects selected");
                else if (filetype == "Local Disk" || filetype == "Removable Disk" || filetype == "Network Drive" ||
                         filetype == "Ram Drive" || filetype == "CD/DVD Drive")
                    dhxFMStatusbar.setText("Free Space: <b>"+free_space+"</b> Total Size: <b>"+total_size+"</b>");
                else
                    dhxFMStatusbar.setText("Type: <b>"+filetype+"</b> Date Modified: <b>"+date_modified+"</b> Size: <b>"+size+"</b>");
            }
            else
                dhxFMStatusbar.setText(ids.length+" objects selected");
        
        }
        else
        {
            dhxMenuBar.setItemDisabled("pasteshort");
            dhxMenuBar.setItemDisabled("copy");
            dhxMenuBar.setItemDisabled("cut");
            //dhxToolbarB.disableItem("views");
            objects=dhxFMGrid.getRowsNum();
            dhxFMStatusbar.setText(objects+" objects");
        }

    }

    function roundNumber(num, dec) {
	var result = Math.round( Math.round( num * Math.pow( 10, dec + 1 ) ) / Math.pow( 10, 1 ) ) / Math.pow(10,dec);
	return result;
    }

    function CutData() {
        Clipboard_Content.length=0;
        if(dhxFMGrid.getSelectedId()) {
            if (dhxFMGrid.editor) return true;
            var ids=dhxFMGrid.getSelectedRowId().split(",");
            dhxFMGrid.clearSelection();

            var data = [];
            data.push("Cut");
            for (var i=0; i<ids.length; i++) {
                data.push(ids[i]);
                dhxFMGrid.setRowTextStyle(ids[i],"opacity:0.5;filter:alpha(opacity=50);");
            }
            Clipboard_Content=data.join("\n");
            dhxMenuBar.setItemEnabled("paste");
            dhxMenuBar.setItemDisabled("pasteshort");
        }
    }

    function CopyData() {
        Clipboard_Content.length=0;
        if(dhxFMGrid.getSelectedId()) {
            if (dhxFMGrid.editor) return true;
            var ids=dhxFMGrid.getSelectedRowId().split(",");

            var data = [];
            data.push("Copy");
            for (var i=0; i<ids.length; i++)
                data.push(ids[i]);
            Clipboard_Content=data.join("\n");
            dhxMenuBar.setItemEnabled("paste");
            dhxMenuBar.setItemEnabled("pasteshort");
        }
    }

    function PasteShortCut() {
        var data=Clipboard_Content.split("\n");
        selid=dhxFMTree.getSelectedItemId();
        var ftype="file";
        if (dhxFMTree.getUserData(selid,"is_writable") == 1) {
            for (var i=1; i<data.length; i++) {
                if (dirname_dir(data[i]) == data[i]) {
                    dir_name=data[i].substring(0,data[i].lastIndexOf('/'));
                    ftype="dir";
                }
                else 
                    ftype="file";

                if (dirname(data[i]) == selid) {
                    var newid=1;
                    var file_exists=0;
                    while (file_exists != -1) {
                        if (newid==1)
                            new_file="Shortcut of ";
                        else
                            new_file="Shortcut ("+newid+") of ";
                        if (ftype == "dir")
                            sid=selid+new_file+basename(dir_name)+"/";
                        else
                            sid=selid+new_file+basename(data[i]);
                        file_exists=dhxFMGrid.getRowIndex(sid);
                        newid++;
                    }
                }
                else
                    sid=selid+basename(data[i]);
                if (ftype == "dir")
                    sid=selid+new_file+basename(dir_name);
                else
                    sid=selid+new_file+basename(data[i]);
                rowId=dhxFMGrid.getRowId(0);
                source=data[i];
                dhxFMGrid.setUserData(rowId,"!nativeeditor_status","shortcut");
                dhxFMGrid.setUserData(rowId,"source",data[i]);
                dhxFMGrid.setUserData(rowId,"destination",selid);
                dhxFMGrid.setUserData(rowId,"newname",sid);
                dhxGridDProcessor.sendData(rowId);
                Clipboard_Content.length=0;
            }
        }
        else
        {
            Clipboard_Content.length=0;
            showError("Error Creating File or Folder", "Cannot create Shortcut "+basename(data[1])+": Access is denied.","Make sure the directory "+dhxFMTree.getSelectedItemText()+" is not write-protected.","error"); 
        }
    }

    function PasteData() {
        var num=dhxFMGrid.getRowsNum();
        var data=Clipboard_Content.split("\n");
        if (data[0] == "Cut")
            mode="cut";
        else if (data[0] == "Copy")
            mode="copy";
        selid=dhxFMTree.getSelectedItemId();
        if (dhxFMTree.getUserData(selid,"is_writable") == 1) {
            if (mode == "copy") {
                var source_type="file";
                var source=new Array();
                for (var i=1; i<data.length; i++) {
                    if (dirname_dir(data[i]) == data[i]) {
                        data[i]=data[i].substring(0,data[i].lastIndexOf('/'));
                        source_type="dir";
                    }
                    else
                        source_type="file";
                    source[i-1]=data[i];
                }
                destination=selid;
                if (source != null) {
                    dhtmlxAjax.get("_include/shellExec.php?task=copy_file&source="+source+"&destination="+destination,
                        function(loader){
                        if(loader.xmlDoc.responseXML!=null) {
                            var params = loader.doXPath("//param");
                            showProgress("Copying...","Copying files...",params[0].firstChild.nodeValue);
                        }
                    });
                }
                var selid = dhxFMTree.getSelectedItemId();
                dhxFMTree.setUserData(selid,"!nativeeditor_status","updated");
                dhxTreeDProcessor.sendData(selid);
            }
            else if (mode == "cut")
            {
                var source=new Array();
                for (var i=1; i<data.length; i++) {
                    if(dhxFMGrid.doesRowExist(data[i]) || dhxFMTree.getSelectedItemId() == data[i]) {
                            showError("Error Moving File or Folder", "Cannot move "+basename(data[1])+": Access is denied.","The source and destination filenames are the same.","error");
                    }
                    else
                        source[i-1]=data[i];
                }
                Clipboard_Content.length=0;
                destination=selid;
                if (source != null) {
                    dhtmlxAjax.get("_include/shellExec.php?task=move_file&source="+source+"&destination="+destination,
                        function(loader){
                        if(loader.xmlDoc.responseXML!=null) {
                            var params = loader.doXPath("//param");
                            showProgress("Moving...","Moving files...",params[0].firstChild.nodeValue);
                        }
                    });
                }
                var selid=dhxFMTree.getParentId(sourceId);
                dhxFMTree.setUserData(selid,"!nativeeditor_status","updated");
                dhxTreeDProcessor.sendData(selid);
                var selid = dhxFMTree.getSelectedItemId();
                dhxFMTree.setUserData(selid,"!nativeeditor_status","updated");
                dhxTreeDProcessor.sendData(selid);
            }
        }
        else
        {
            Clipboard_Content.length=0;
            showError("Error Copying File or Folder", "Cannot copy "+basename(data[1])+": Access is denied.","Make sure the directory "+dhxFMTree.getSelectedItemText()+" is not write-protected.","error"); 
        }
    }

    function onKeyBPressed(code,ctrl,shift){
        // Enter Pressed
        if(code==13){
            if (dhxFMGrid.editor) return true;
            if(dhxFMGrid.getSelectedId())
                showFileContent(dhxFMGrid.getSelectedId());
        }
        // Ctrl+C Pressed
        if(code==67&&ctrl){
            if (dhxFMGrid.editor) return true;
            CopyData();
        }
        // Ctrl+V Pressed
        if(code==86&&ctrl){
            if (dhxFMGrid.editor) return true;
            PasteData();
        }
        // Del Key Pressed
        if(code==46){
            if (dhxFMGrid.editor) return true;
            if(dhxFMGrid.getSelectedId())
                deleteSelectedId();
        }
        // Ctrl+X Cut Pressed
        if(code==88&&ctrl){
            if (dhxFMGrid.editor) return true;
            CutData();
        }
        return true;
    }

    function numOrdA(a, b){ return (a-b); }
    function numOrdD(a, b){ return (b-a); }

    function basename(path) { return path.replace( /.*\//, "" ); }

    function dirname(path) { 
        var newpath=path.match( /.*\// ); 
        if (newpath == path) {
            return dirname(path.substring(0,path.lastIndexOf('/')));
        }
        else
            return newpath[0];
    }

    function dirname_dir(path) { 
        return path.match( /.*\// ); }

    function deleteSelectedId(){
        selid=dhxFMTree.getSelectedItemId();
        var ids=dhxFMGrid.getSelectedId().split(',');
        if (dhxFMTree.getUserData(selid,"is_writable") == 1)
        {
            if (ids.length>1){
                message="Are you sure you want to delete these "+ids.length+" items?";
                header="Confirm Multiple File Delete";
            }
            else
            {
                if (dhxFMGrid.cells(ids[0], 3).getValue() == "File Folder")
                {
                    mystr = ids[0].split("/");
                    message="Are you sure you want to remove the folder \n'"+mystr[mystr.length-2]+"' and all its contents?";
                    header="Confirm Folder Delete";
                }
                else{
                    message="Are you sure you want to delete '"+basename(ids[0])+"'?";
                    header="Confirm File Delete";
                }
            }
            deleteSelectedFiles(header,message);
        }
        else
        {
            name = dhxFMGrid.cells(ids[0],1).getValue();
            showError("Error Deleting File or Folder", "Cannot delete "+name+": Access is denied.","Make sure the directory "+dhxFMTree.getSelectedItemText()+" is not write-protected.","error");
        }
    }

    dhtmlxEvent(window,"resize",function(){
        dhxFMGrid.setSizes();
        dhxFMLayout.cells("b").fixSize(true);
    });

//    window.setInterval(function(){
//        dhxFMStatusbar.setText(dhxFMGrid.getRowsNum()+" objects");
//    },100)

    function selectTreeNode(id){
    switch(id){
        case id:
            dhxFMTree.openItem(id);
            if (id == "popcornhour")
                dhxToolbarB.disableItem("up");
            else
                dhxToolbarB.enableItem("up");

            if (view_type == "details")
            {
                dhxFMGrid.setColumnHidden(11,true);
                dhxFMGrid.setColumnHidden(12,true);
                dhxFMGrid.setColumnHidden(13,true);
                dhxFMGrid.setColumnHidden(14,true);
                dhxFMGrid.setColumnHidden(15,true);
                dhxFMGrid.setColumnHidden(16,true);
                dhxFMGrid.setColumnHidden(17,true);
                if (id == "popcornhour" )
                {
                    dhxFMGrid.setColumnHidden(2,true);
                    dhxFMGrid.setColumnHidden(4,true);
                    dhxFMGrid.setColumnHidden(5,true);
                    dhxFMGrid.setColumnHidden(6,true);
                    dhxFMGrid.setColumnHidden(7,false);
                    dhxFMGrid.setColumnHidden(8,false);
                    dhxFMGrid.setColumnHidden(9,false);
                    dhxFMGrid.setColumnHidden(10,false);
                }
                else
                {
                    dhxFMGrid.setColumnHidden(7,true);
                    dhxFMGrid.setColumnHidden(8,true);
                    dhxFMGrid.setColumnHidden(9,true);
                    dhxFMGrid.setColumnHidden(10,true);
                    if (dhxFMTree.getUserData(id,"is_readable") == 1) {
                        if (dhxFMTree.getUserData(id,"content") == "Music") {
                            dhxFMGrid.setColumnHidden(4,true);
                            dhxFMGrid.setColumnHidden(5,true);
                            dhxFMGrid.setColumnHidden(6,true);
                            dhxFMGrid.setColumnHidden(11,false);
                            dhxFMGrid.setColumnHidden(12,false);
                            dhxFMGrid.setColumnHidden(13,false);
                            dhxFMGrid.setColumnHidden(14,false);
                            dhxFMGrid.setColumnHidden(15,false);
                            dhxFMGrid.setColumnHidden(16,true);
                            dhxFMGrid.setColumnHidden(17,true);
                        }
                        else if (dhxFMTree.getUserData(id,"content") == "Photo") {
                            dhxFMGrid.setColumnHidden(5,true);
                            dhxFMGrid.setColumnHidden(6,true);
                            dhxFMGrid.setColumnHidden(11,true);
                            dhxFMGrid.setColumnHidden(12,true);
                            dhxFMGrid.setColumnHidden(13,true);
                            dhxFMGrid.setColumnHidden(14,true);
                            dhxFMGrid.setColumnHidden(15,true);
                            dhxFMGrid.setColumnHidden(16,false);
                            dhxFMGrid.setColumnHidden(17,false);
                        }
                        else if (dhxFMTree.getUserData(id,"content") == "Video") {
                            dhxFMGrid.setColumnHidden(5,true);
                            dhxFMGrid.setColumnHidden(6,true);
                            dhxFMGrid.setColumnHidden(11,true);
                            dhxFMGrid.setColumnHidden(12,true);
                            dhxFMGrid.setColumnHidden(13,true);
                            dhxFMGrid.setColumnHidden(14,true);
                            dhxFMGrid.setColumnHidden(15,false);
                            dhxFMGrid.setColumnHidden(16,false);
                            dhxFMGrid.setColumnHidden(17,true);
                        }
                        else {
                            dhxFMGrid.setColumnHidden(2,false);
                            dhxFMGrid.setColumnHidden(4,false);
                            dhxFMGrid.setColumnHidden(5,false);
                            dhxFMGrid.setColumnHidden(6,false);
                        }
                    }
                    else {
                        dhxFMTree.selectItem(last_selected);
                        showError("Access is denied",id+" is not accessible.","Access is denied.","error");
                        break;
                    }
                }
                if (last_selected != id)
                {
                    dhxFMGrid.clearAll();
                    dhxFMGrid.loadXML("_include/getDirContent.php?dir="+id.replace(/&/g,"%26").replace(/\+/g,"%2B"));
                    dhxToolbarB.enableItem("back");

                    if (add_to_history == 1) {
                        hist_id=dhxFMTree.getItemText(last_selected);
                        hist_img=dhxFMTree.getUserData(last_selected,"image");

                        var loader = dhtmlxAjax.get("_include/shellExec.php?task=last_browsed&id="+id);
                        //dhxFMTree.saveOpenStates();
                        dhxToolbarB.addListOption("back", last_selected, 1, "button", hist_id, hist_img);
                    }
                    add_to_history=1;
                    last_selected=id;
                }
                else
                    dhxFMGrid.updateFromXML("_include/getDirContent.php?dir="+id.replace(/&/g,"%26").replace(/\+/g,"%2B"), true, true);
            }
            else if (view_type == "tiles")
            {
                dhxFoldersA.clearAll();
                dhxFoldersA.loadXML("_include/getDirContent.php?type=icons&dir="+id, "_js/dhtmlx/types/ftiles.xsl");
                last_selected=id;
            }
            else if (view_type == "icons")
            {
                dhxFoldersB.clearAll();
                dhxFoldersB.loadXML("_include/getDirContent.php?type=icons&dir="+id, "_js/dhtmlx/types/ficon.xsl");
                last_selected=id;
            }
        }

        if(Clipboard_Content.length != 0) {
            var data=Clipboard_Content.split("\n");
            if (data[0] == "Cut")
                mode="cut";
            else if (data[0] == "Copy")
                mode="copy";
            else 
                mode="";

            selid=dhxFMTree.getSelectedItemId();
            if (selid != "popcornhour") {
                if (mode == "cut"){
                    dhxMenuBar.setItemEnabled("paste");
                    dhxMenuBar.setItemDisabled("pasteshort");
                }
                else if (mode == "copy"){
                    dhxMenuBar.setItemEnabled("paste");
                    dhxMenuBar.setItemEnabled("pasteshort");
                }
                else {
                    dhxMenuBar.setItemDisabled("paste");
                    dhxMenuBar.setItemDisabled("pasteshort");
                }
            }
            else {
                dhxMenuBar.setItemDisabled("paste");
                dhxMenuBar.setItemDisabled("pasteshort");
            }
        }
        dhxFMGrid.setActive(true);
    }

    function onRightClick(rowId, cellInd, grid) {
        if (cellInd != 1 )
            dhxFMGrid.clearSelection();
        if (! dhxFMGrid.getSelectedRowId())
            dhxFMGrid.selectRowById(rowId, false, true,true);
        return true;
    }

    function onShowMenu(rowId, celInd, grid){
        if (celInd == 1 && rowId != undefined)
        {
            var ids=dhxFMGrid.getSelectedRowId().split(",");
            if (ids.indexOf(rowId) == -1)
                dhxFMGrid.selectRowById(rowId, false, true,true);
            
            var ids=dhxFMGrid.getSelectedRowId().split(",");
            disableMenuB();
            if (ids.length == 1) {
                filename = basename(dhxFMGrid.cells(rowId,1).getValue());
                filetype = dhxFMGrid.cells(rowId,3).getValue();
                dhxGridMenu.hideItem("sep02");
                dhxGridMenu.showItem("cut");
                dhxGridMenu.showItem("copy");
                dhxGridMenu.showItem("sep03");
                dhxGridMenu.showItem("pasteshort");
                dhxGridMenu.showItem("delete");
                dhxGridMenu.showItem("rename");
                dhxGridMenu.showItem("save");
                switch(filetype){
                    case 'Local Disk':
                    case 'Network Drive':
                    case 'Ram Drive':
                    case 'CD/DVD Drive':
                    case 'Removable Disk':
                        dhxGridMenu.showItem("explore");
                        dhxGridMenu.hideItem("sep02");
                        dhxGridMenu.hideItem("cut");
                        dhxGridMenu.hideItem("copy");
                        dhxGridMenu.hideItem("sep03");
                        dhxGridMenu.hideItem("pasteshort");
                        dhxGridMenu.hideItem("delete");
                        dhxGridMenu.hideItem("rename");
                        dhxGridMenu.hideItem("save");
                        break;
                    case 'File Folder':
                        dhxGridMenu.showItem("explore");
                        dhxGridMenu.showItem("sep02");
                        dhxGridMenu.hideItem("save");
                        break;
                    case 'HJSplit File':
                        var itemText="Join as "+filename.substring(0,filename.lastIndexOf('.'));
                        dhxGridMenu.setItemText("hj1", itemText);
                        dhxGridMenu.showItem("hj");
                        dhxGridMenu.showItem("sep02");
                        break;
                    case 'BZIP2 Archive':
                        dhxGridMenu.showItem("bz2");
                        dhxGridMenu.showItem("sep02");
                        break;
                    case 'GZIP Archive':
                        dhxGridMenu.showItem("gz");
                        dhxGridMenu.showItem("sep02");
                        break;
                    case 'ZIP Archive':
                        dhxGridMenu.showItem("zip");
                        dhxGridMenu.showItem("sep02");
                        var itemText="Extract to "+filename.substring(0,filename.lastIndexOf('.'))+"/";
                        dhxGridMenu.setItemText("zip2", itemText);
                        break;
                    case 'RAR Archive':
                        dhxGridMenu.showItem("rar");
                        dhxGridMenu.showItem("sep02");
                        var itemText="Extract to "+filename.substring(0,filename.lastIndexOf('.'))+"/";
                        dhxGridMenu.setItemText("rar2", itemText);
                        break;
                    case 'TAR Archive':
                        dhxGridMenu.showItem("tar");
                        dhxGridMenu.showItem("sep02");
                        var itemText="Extract to "+filename.substring(0,filename.lastIndexOf('.'))+"/";
                        dhxGridMenu.setItemText("tar2", itemText);
                        break;
                    case 'Text Document':
                    case 'PHP Script':
                    case 'SQL File':
		    case 'PERL Script':
                    case 'HTML Page':
                    case 'Javascript File':
		    case 'CSS File':
                    case 'CGI Script':
                    case 'C++ Header File':
		    case 'C++ Source File':
                    case 'Java Source File':
                    case 'GIF Image':
                    case 'JPG Image':
                    case 'PNG Image':
                        dhxGridMenu.showItem("view");
                        dhxGridMenu.showItem("sep02");
                        break;
                    case 'MPG Video File':
                    case 'Quick Time Movie File':
                    case 'Video Clip':
                    case 'Matroska Video File':
                    case 'Windows Media Audio/Video File':
                        dhxGridMenu.showItem("play");
                        dhxGridMenu.showItem("sep02");
                        break;
                }
            }
            return true;
        }
        else
            return false;
    }

    function onTreeRightClick(treenodeId){
        prev_treenodeId=dhxFMTree.getSelectedItemId();
        dhxFMTree.selectItem(treenodeId);
        dhxTreeMenu.hideItem('collapse');
        dhxTreeMenu.hideItem('expand');
        has_child=dhxFMTree.hasChildren(treenodeId);
        is_open=dhxFMTree.getOpenState(treenodeId);
        is_internal=dhxFMTree.getUserData(treenodeId,"is_internal");
        selid=dhxFMTree.getParentId(treenodeId);

        dhxTreeMenu.forEachItem(function(itemId){
            if (dhxTreeMenu.getParentId(itemId) == 'show') {
                if(dhxFMTree.getIndexById(itemId+'/') == null)
                    dhxTreeMenu.setCheckboxState(itemId,false);
                else
                    dhxTreeMenu.setCheckboxState(itemId,true);
            }
        });

        if (is_open==0 && has_child!=0)
            dhxTreeMenu.showItem('expand');
        else if (is_open==-1 && has_child!=0)
            dhxTreeMenu.showItem('expand');
        else if (is_open==1 && has_child!=0)
            dhxTreeMenu.showItem('collapse');

        if (treenodeId == 'popcornhour') {
            dhxTreeMenu.showItem('map');
            dhxTreeMenu.showItem('unmap');
            dhxTreeMenu.hideItem('sharing');
            dhxTreeMenu.hideItem('delete');
            dhxTreeMenu.hideItem('rename');
            dhxTreeMenu.hideItem('eject');
            dhxTreeMenu.hideItem('sep04');
            dhxTreeMenu.hideItem('hide');
            dhxTreeMenu.showItem('show');
        }
        else if (selid == 'popcornhour') {
            if (is_internal == 0) {
                dhxTreeMenu.hideItem('map');
                dhxTreeMenu.hideItem('unmap');
                dhxTreeMenu.showItem('sharing');
                dhxTreeMenu.hideItem('delete');
                dhxTreeMenu.hideItem('rename');
                dhxTreeMenu.showItem('eject');
                dhxTreeMenu.hideItem('sep04');
                dhxTreeMenu.hideItem('sep03');
                dhxTreeMenu.hideItem('hide');
                dhxTreeMenu.hideItem('show');
            }
            else {
                dhxTreeMenu.hideItem('map');
                dhxTreeMenu.hideItem('unmap');
                dhxTreeMenu.showItem('sharing');
                dhxTreeMenu.hideItem('delete');
                dhxTreeMenu.showItem('rename');
                dhxTreeMenu.hideItem('eject');
                dhxTreeMenu.showItem('sep04');
                dhxTreeMenu.showItem('hide');
                dhxTreeMenu.hideItem('show');
            }
        }
        else {
            dhxTreeMenu.hideItem('map');
            dhxTreeMenu.hideItem('unmap');
            dhxTreeMenu.showItem('sharing');
            dhxTreeMenu.showItem('delete');
            dhxTreeMenu.showItem('rename');
            dhxTreeMenu.hideItem('eject');
            dhxTreeMenu.hideItem('sep04');
            dhxTreeMenu.hideItem('hide');
            dhxTreeMenu.hideItem('show');
        }
        return true;
    }

    function enableToolbarB(){
        //dhxToolbarB.disableItem("views");
    }

    function disableToolbarB(){
        dhxToolbarB.disableItem("up");
        dhxToolbarB.disableItem("back");
        dhxToolbarB.disableItem("forward");
        dhxToolbarB.setItemText("back", "Back");
        //dhxToolbarB.disableItem("views");
    }

    function showFileContent(id){
        if (view_type == "details") {
            data=dhxFMGrid.cells(id,1).getValue();
            type=dhxFMGrid.cells(id,3).getValue();
            if (type == "File Folder" || type == "Local Disk" || type == "Network Drive" ||
 		type == "Removable Disk" || type == "Ram Drive" || type == "CD/DVD Drive" ||
                type == "Symbolic Link") {
                if (dhxFMTree.getIndexById(id) != null) {
                    selid=dhxFMGrid.getSelectedRowId();
                    dhxFMTree.selectItem(selid, true);
                    dhxFMTree.openItem(selid);
                    last_selected=selid;
                    dhxFMGrid.clearAll();
                    dhxFMGrid.loadXML("_include/getDirContent.php?dir="+selid.replace(/&/g,"%26").replace(/\+/g,"%2B"));
                    dhxFMStatusbar.setText(dhxFMGrid.getRowsNum()+" objects");
                }
            }
        }
        else if (view_type == "icons") {
            var xmlNode = dhxFoldersB.getItemDataObject(dhxFoldersB._activeItemId);
            type = xmlNode.getAttribute("filetype");
            if (type == "File Folder" || type == "Local Disk" || type == "Network Drive" ||
 			type == "Removable Disk" || type == "Ram Drive" || type == "CD/DVD Drive") {
                selid=dhxFoldersB.getSelectedId();
                dhxFMTree.selectItem(selid);
                dhxFMTree.openItem(selid);
                last_selected=selid;
                dhxFoldersB.clearAll();
                dhxFoldersB.loadXML("_include/getDirContent.php?type=icons&dir="+selid, "_js/dhtmlx/types/ficon.xsl");
                dhxFMStatusbar.setText(dhxFoldersB.getItemsNum()+" objects");
            }
        }
        else if (view_type == "tiles") {
            var xmlNode = dhxFoldersA.getItemDataObject(dhxFoldersA._activeItemId);
            type = xmlNode.getAttribute("filetype");
            if (type == "File Folder" || type == "Local Disk" || type == "Network Drive" ||
 			type == "Removable Disk" || type == "Ram Drive" || type == "CD/DVD Drive") {
                selid=dhxFoldersA.getSelectedId();
                dhxFMTree.selectItem(selid);
                dhxFMTree.openItem(selid);
                last_selected=selid;
                dhxFoldersA.clearAll();
                dhxFoldersA.loadXML("_include/getDirContent.php?type=tiles&dir="+selid, "_js/dhtmlx/types/ftiles.xsl");
                dhxFMStatusbar.setText(dhxFoldersA.getItemsNum()+" objects");
            }
        }
    }

    dhxFMLayout.attachEvent("onCollapse", function(itemId){
        dhxToolbarB.setItemState("folders",0);
    });

    dhxFMLayout.attachEvent("onExpand", function(itemId){
        dhxToolbarB.setItemState("folders",1);
    });

    dhxToolbarB.attachEvent("onStateChange", function(id, state){
        if (state == 0)
            dhxFMLayout.cells("a").collapse();
        else
            dhxFMLayout.cells("a").expand();
 
    });

    dhxToolbarB.attachEvent("onClick", function(id){
    switch(id){
        case 'back':
            var ids = dhxToolbarB.getAllListOptions('back');
            addid=dhxFMTree.getSelectedItemId();
            addtext=dhxFMTree.getItemText(addid);
            hist_img=dhxFMTree.getUserData(addid,"image");
            hist_txt = dhxToolbarB.getListOptionText("back", ids[ids.length-1]);
            dhxToolbarB.removeListOption("back", ids[ids.length-1]);
            add_to_history=0;
            dhxFMTree.selectItem(ids[ids.length-1], true);
            dhxToolbarB.enableItem("forward");
            dhxToolbarB.addListOption("forward", addid, 1, "button", addtext, hist_img);

            var ids = dhxToolbarB.getAllListOptions('back');
            if (ids.length == 0)
                dhxToolbarB.disableItem("back");
            break;
        case 'forward':
            var ids = dhxToolbarB.getAllListOptions('forward');
            addid=dhxFMTree.getSelectedItemId();
            addtext=dhxFMTree.getItemText(addid);
            hist_img=dhxFMTree.getUserData(addid,"image");
            hist_txt = dhxToolbarB.getListOptionText("forward", ids[ids.length-1]);
            dhxToolbarB.removeListOption("forward", ids[ids.length-1]);
            add_to_history=0;
            dhxFMTree.selectItem(ids[ids.length-1], true);
            dhxToolbarB.enableItem("back");
            dhxToolbarB.addListOption("back", addid, 1, "button", addtext, hist_img);

            var ids = dhxToolbarB.getAllListOptions('forward');
            if (ids.length == 0)
                dhxToolbarB.disableItem("forward");
            break;
        case 'up':
            selid=dhxFMTree.getParentId(dhxFMTree.getSelectedItemId());
            dhxFMTree.selectItem(selid, true);
            break;
        case 'refresh':
            selid=dhxFMTree.getSelectedItemId();
            if (view_type == "details") {
                dhxFMTree.smartRefreshItem(selid, "_include/getDirTree.php");
                //dhxFMGrid.clearAll();
                dhxFMGrid.updateFromXML("_include/getDirContent.php?dir="+selid.replace(/&/g,"%26").replace(/\+/g,"%2B"), true, true);
            }
            else if (view_type == "icons") {
                dhxFoldersB.clearAll();
                dhxFoldersB.loadXML("_include/getDirContent.php?type=icons&dir="+selid, "_js/dhtmlx/types/ficon.xsl");
            }
            else if (view_type == "tiles"){
                dhxFoldersA.clearAll();
                dhxFoldersA.loadXML("_include/getDirContent.php?type=icons&dir="+selid, "_js/dhtmlx/types/ftiles.xsl");
            }
            break;
        case 'details':
            ChangeView("details");
            break;
        case 'tiles':
            ChangeView("tiles");
            break;
        case 'icons':
            ChangeView("icons");
            break;
        case id:
            dhxToolbarB.forEachListOption('back', function(optionId){
                if (optionId == id) {
                    parentId='back';
                    oparentId='forward';
                }
            });
            dhxToolbarB.forEachListOption('forward', function(optionId){
                if (optionId == id) {
                    parentId='forward';
                    oparentId='back';
                }
            });

            dhxFMTree.selectItem(id, true);

            var ids = dhxToolbarB.getAllListOptions(parentId);
            ids.reverse();
            var pos = dhxToolbarB.getListOptionPosition(parentId, id);
            for (var j=0; j<pos-1; j++) {
                hist_txt = dhxToolbarB.getListOptionText(parentId, ids[j]);
                hist_img = basename(dhxToolbarB.getListOptionImage(parentId, ids[j]));
                dhxToolbarB.removeListOption(parentId, ids[j]);
                dhxToolbarB.enableItem(oparentId);
                dhxToolbarB.addListOption(oparentId, ids[j], 1, "button", hist_txt, hist_img);
            }
            dhxToolbarB.removeListOption(parentId, id);
            var ids = dhxToolbarB.getAllListOptions(parentId);
            if (ids.length == 0)
                dhxToolbarB.disableItem(parentId);

            break;
        }
    });

    window.addEvent('domready', function() {
        Sexy = new SexyAlertBox();
    });

    function onHeaderClick(id){
        state = dhxFMGrid.getSortingState(id);
        if (state[1] == "asc")
            srt_ord="des";
        else
            srt_ord="asc";
        srt_clmn=id;
        if (id == 1)
        {
            dhxEmptyGridMenu.setRadioChecked("arrange","name");
            dhxMenuBar.setRadioChecked("arrange","name");
        }
        else if (id == 2)
        {
            dhxEmptyGridMenu.setRadioChecked("arrange","size");
            dhxMenuBar.setRadioChecked("arrange","size");
        }
        else if (id == 3)
        {
            dhxEmptyGridMenu.setRadioChecked("arrange","type");
            dhxMenuBar.setRadioChecked("arrange","type");
        }
        else if (id == 4)
        {
            dhxEmptyGridMenu.setRadioChecked("arrange","modified");
            dhxMenuBar.setRadioChecked("arrange","modified");
        }

        return true;
    }

    function ChangeView(view){
        if(view=="tiles"){
            if (view_type != "tiles") {
                dhxFoldersA=dhxFMLayout.cells("b").attachFolders();
                dhxFoldersA.enableSelection(true);
                dhxFoldersA.setItemType("ftiles");
                dhxFoldersA.attachEvent("ondblclick",showFileContent);
                dhxFoldersA.setUserData("icons_src_dir","_img/48x48/");
                dhxFoldersA.enableContextMenu(dhxGridMenu);
                selid=dhxFMTree.getSelectedItemId();
                if (selid == "")
                    selid="popcornhour";
                dhxFoldersA.loadXML("_include/getDirContent.php?type=tiles&dir="+selid, "_js/dhtmlx/types/ftiles.xsl");
                view_type="tiles";
                //dhxFoldersA.objBox.id=dhxFoldersA.uid();
                //dhxEmptyGridMenu.addContextZone(dhxFoldersA.objBox.id);

                dhxFoldersA.attachEvent("onXLE",function(){
                    objects=dhxFoldersA.getItemsNum();
                    dhxFMStatusbar.setText(objects+" objects");
                });
            }
        }
        else if(view=="icons"){
            if (view_type != "icons") {
                dhxFoldersB=dhxFMLayout.cells("b").attachFolders();
                dhxFoldersB.enableSelection(true);
                dhxFoldersB.setItemType("ficon");
                dhxFoldersB.attachEvent("ondblclick",showFileContent);
                dhxFoldersB.setUserData("icons_src_dir","_img/32x32/");
                dhxFoldersB.enableContextMenu(dhxGridMenu);
                selid=dhxFMTree.getSelectedItemId();
                if (selid == "")
                    selid="popcornhour";
                dhxFoldersB.loadXML("_include/getDirContent.php?type=icons&dir="+selid, "_js/dhtmlx/types/ficon.xsl");
                view_type="icons";
                //dhxFoldersB.objBox.id=dhxFoldersB.uid();
                //dhxEmptyGridMenu.addContextZone(dhxFoldersB.objBox.id);

                dhxFoldersB.attachEvent("onXLE",function(){
                    objects=dhxFoldersB.getItemsNum();
                    dhxFMStatusbar.setText(objects+" objects");
                });
            }
        }
        else if(view=="details"){
            if (view_type != "details") {
                dhxFMGrid = dhxFMLayout.cells("b").attachGrid();
                dhxFMGrid.preventIECaching(true);
                dhxFMGrid.setImagePath("_js/dhtmlx/imgs/")
                dhxFMGrid.setHeader(",Name,Size,Type,Date Modified,Rights,Owner,Total Size,Free Space,File System,Comments,Artist,Album Title,Year,Track,Duration,Dimensions,Date Picture Taken");
                //dhxFMGrid.setColTypes("img,ed,ron,ro,ro,ro,ro,ro,ro,ro,ro,ro,ro,ro,ro,ro,ro,ro");
                dhxFMGrid.setColTypes("img,ed,ron,ro,ro,ro,ro,ro,ro,ro,ro,ro,ro,ro,ro,ro,ro,ro");
                dhxFMGrid.setColumnIds("img,name,size,type,modified,rights,owner,total_size,free_space,file_system,comments,artist,album_title,year,track,duration,dimensions,date_picture_taken");
                dhxFMGrid.setInitWidths("22,300,100,100,150,100,*,100,100,100,*,100,100,75,75,*,100,*");
                dhxFMGrid.enableResizing("false,true,true,true,true,true,true,true,true,true,true,true,true,true,true,true,true,true")
                dhxFMGrid.setColAlign("center,left,right,left,left,left,left,right,right,left,left,left,left,left,left,left,left,left");
                dhxFMGrid.enableTooltips("false,false,false,false,false,false,false,false,false,false,false,false,false,false,false,false,false,false");
                dhxFMGrid.setSkin(defaultSkin);
                dhxFMGrid.setColSorting("na,str,int,str,str,str,str,str,str,str,str,str,str,str,str,str,str,str");
                selid=dhxFMTree.getSelectedItemId();
                if (selid == "")
                    selid="popcornhour";
                dhxFMGrid.enableSmartRendering(true,30);
                dhxFMGrid.enableDistributedParsing(true,30,300);
                dhxFMGrid.loadXML("_include/getDirContent.php?type=details&dir="+selid.replace(/&/g,"%26").replace(/\+/g,"%2B"));
                dhxFMGrid.enableAlterCss("even_row","odd_row")
                dhxFMGrid.init();
                dhxFMGrid.setNumberFormat("0,000 KB",2);
                if (selid == "popcornhour") {
                    dhxFMGrid.setColumnHidden(2,true);
                    dhxFMGrid.setColumnHidden(4,true);
                    dhxFMGrid.setColumnHidden(5,true);
                    dhxFMGrid.setColumnHidden(6,true);
                    dhxFMGrid.setColumnHidden(7,false);
                    dhxFMGrid.setColumnHidden(8,false);
                    dhxFMGrid.setColumnHidden(9,false);
                    dhxFMGrid.setColumnHidden(10,false);
                }
                dhxFMGrid.setColumnHidden(11,true);
                dhxFMGrid.setColumnHidden(12,true);
                dhxFMGrid.setColumnHidden(13,true);
                dhxFMGrid.setColumnHidden(14,true);
                dhxFMGrid.setColumnHidden(15,true);
                dhxFMGrid.setColumnHidden(16,true);
                dhxFMGrid.setColumnHidden(17,true);
                dhxFMGrid.setSortImgState(true,1,"asc");
                dhxFMGrid.enableMultiselect(true);

                dhxFMGrid.attachEvent("onRowDblClicked", showFileContent);
                dhxFMGrid.attachEvent("onRowSelect",doOnFMGridSelected);
                dhxFMGrid.attachEvent("onKeyPress",onKeyBPressed);
                dhxFMGrid.attachEvent("onBeforeContextMenu",onShowMenu);
                dhxFMGrid.attachEvent("onRightClick",onRightClick);
                dhxFMGrid.attachEvent("onHeaderClick",onHeaderClick);
                dhxFMGrid.enableContextMenu(dhxGridMenu);
                dhxFMGrid.attachEvent("onEditCell",doOnCellEdit);
                dhxFMGrid.enableDragAndDrop(true);
                dhxFMGrid.setDragText("object");

                dhxFMGrid.attachEvent("onBeforeDrag",function(sourceID) {
                    filetype = dhxFMGrid.cells(sourceID,3).getValue();
                    selid=dhxFMTree.getSelectedItemId();
                    if (filetype != "Local Disk" && filetype != "Removable Disk" && filetype != "Network Drive" &&
                        filetype != "Ram Drive" && filetype != "CD/DVD Drive") {
                        if (dhxFMTree.getUserData(selid,"is_writable") == 1)
                            return true;
                    }
                    else
                        return false;
                });

                dhxFMGrid.attachEvent("onDragIn",function(sourceID, targetID, sourceGrid, targetGrid){
                    filetype = dhxFMGrid.cells(targetID,3).getValue();
                    if (filetype == "File Folder" && dhxFMGrid.getUserData(targetID,"is_writable") == 1)
                        return "Test";
                    else
                        return false;
                });

                dhxFMGrid.attachEvent("onDrop",function(sourceID, targetID, targetID_copy, sourceGrid, targetGrid){
                    var ids=sourceID.split(',');
                    for (var i=0; i<ids.length; i++) {
                        rowId=dhxFMGrid.getRowId(0);
                        dhxFMGrid.setUserData(rowId,"!nativeeditor_status","move_file");
                        dhxFMGrid.setUserData(rowId,"source",ids[i]);
                        dhxFMGrid.setUserData(rowId,"destination",targetID);
                        dhxGridDProcessor.sendData(rowId);
                    }
                    dhxFMTree.setUserData(targetID,"!nativeeditor_status","updated");
                    dhxTreeDProcessor.sendData(targetID);
                    if (dirname_dir(sourceID) == sourceID){
                        dhxFMTree.setUserData(sourceID,"!nativeeditor_status","deleted");
                        dhxTreeDProcessor.sendData(sourceID);
                    }
                    return true;
                });

                view_type="details";
                dhxFMGrid.attachEvent("onXLE",function(){
                    objects=dhxFMGrid.getRowsNum();
                    if (dhxFMTree.getSelectedItemId() != "popcornhour") {
                        dhxFMGrid.setRowHidden(dhxFMGrid.getRowId(0), true);
                        dhxFMGrid.setRowHidden(dhxFMGrid.getRowId(1), true);
                        if (objects >=2)
                            objects=objects-2;
                        dhxFMGrid.sortRows(srt_clmn, "str", srt_ord);
                    }
                    dhxFMGrid.setSortImgState(true,srt_clmn,srt_ord);
                    dhxFMStatusbar.setText(objects+" objects");
                    //width=dhxFMLayout.cells("b").getWidth();
                    //height=dhxFMLayout.cells("b").getHeight();
                });
               dhxFMGrid.objBox.id=dhxFMGrid.uid();
               dhxEmptyGridMenu.addContextZone(dhxFMGrid.objBox.id);
            }
        }
    }

    function create_DIV(id, img){
        var div = document.createElement('DIV');
        div.setAttribute('id', id);
        div.style.background="#F0F8FF";

        var table='<form name="errorform"><table style="font-family:Tahoma;font-size:12px;" style="margin-top:10px;margin-bottom:0px;margin-right:15px;"><tbody><tr><td align="left" style="vertical-align:top;">&nbsp;&nbsp;<img src="_img/32x32/error.png"></td><td>&nbsp;&nbsp;</td>';
        table +='<td style="vertical-align:top;" align="left"><div id="text1">dummy</div></td></tr><tr><td></td><td>&nbsp;&nbsp;</td><td align="left"><div id="text2">dummy</div></td></tr><tr><td></td></tr></tbody></table>';
        table +='<table width="100%" align="center"><hr><tbody><tr><td colspan="2" align="center" width="100%">';
        table +='<input type="button" style="width:100;" name="ok" value="OK" onclick="errorwins.close();"></td></tr></tbody></table> </form>';

        div.style.overflow="hidden"; 
        document.body.appendChild(div);
        document.getElementById(id).innerHTML=table;
    }

    function showError(header,text1,text2,type) {
        dhxErrorWin.setSkin(defaultSkin); 
        dhxErrorWin.setImagePath("_js/dhtmlx/imgs/");
        if (type == "about")
            create_DIV("error_dlg","_img/about.png");
        else if (type == "error")
            create_DIV("error_dlg","_img/error.png");
        document.getElementById('text1').innerHTML = text1;
        document.getElementById('text2').innerHTML = text2;
        width=document.getElementById('text1').offsetWidth+90;
        if (height == 0)
            height=document.getElementById('error_dlg').offsetHeight+62;
        errorwins=dhxErrorWin.createWindow("w1",10,10,width,height);
        errorwins.setText(header);
        errorwins.center();
        errorwins.denyResize();
        errorwins.denyPark();
        errorwins.button("park").hide();
        errorwins.button("minmax1").hide();
        errorwins.setModal(true);
        errorwins.attachObject("error_dlg");
        dhxFMGrid.setActive(true);
    }

    function showConfirm(header,text1) {
        ok_pressed=false;
        dhxConfirmWin.setSkin(defaultSkin); 
        dhxConfirmWin.setImagePath("_js/dhtmlx/imgs/");
        confirmwins=dhxConfirmWin.createWindow("w1",10,10,400,170);
        confirmwins.setText(header);
        confirmwins.center();
        confirmwins.denyResize();
        confirmwins.denyPark();
        confirmwins.button("park").hide();
        confirmwins.button("minmax1").hide();
        confirmwins.setModal(true);
        confirmwins.attachURL("_include/showConfirm.php?text1="+text1);
    }

    function deleteSelectedFiles(header, message) {
        showConfirm(header, message);
        dhxConfirmWin.attachEvent("onClose", function() {
            if (ok_pressed) {
                //disableToolbarB();
                var ids=dhxFMGrid.getSelectedRowId().split(",");
                for (var i=0;i<ids.length;i++) {
                    dhxFMGrid.setUserData(ids[i],"!nativeeditor_status","delete_file");
                    dhxGridDProcessor.sendData(ids[i]);
                }
            }
            dhxFMGrid.setActive(true);
            return true;
        });
    }

    function monitorProcess(pid){
        intervalID=window.setInterval(function()
            { checkProcess(pid)},1000);
    } 

    function splitLine(st,n) {
        var b = '';
        var s = st;
        while (s.length > n) {
            var c = s.substring(0,n);
            var d = c.lastIndexOf(' ');
            var e =c.lastIndexOf('\n');
            if (e != -1) d = e;
            if (d == -1) d = n;
            b +=       c.substring(0,d) + '<br>';
            s = s.substring(d+1);
        }
        return b+s;
    }

    function checkProcess(pid){
        dhtmlxAjax.get("_include/shellExec.php?task=check_pid&pid="+pid,
            function(loader){
            if(loader.xmlDoc.responseXML!=null) {
                var params = loader.doXPath("//param");
                error=params[0].firstChild.nodeValue;
                if (error == "error") {
                    error1=params[1].firstChild.nodeValue;
                    window.clearInterval(intervalID);
                    etxt=dhxProgressWin.window("w1").getText();
                    dhxProgressWin.window("w1").close();
                    error1=splitLine(error1,150);
                    showError("Error while "+etxt,"Error while "+etxt,error1,"error");
                }
                else if (error == "no") {
                    if (_isIE) {
                        window.clearInterval(intervalID);
                        if (dhxProgressWin.isWindow("w1")){
                            dhxProgressWin.window("w1")._frame.contentWindow.document.getElementById("cancel").value="Close";
                            dhxProgressWin.window("w1")._frame.contentWindow.document.getElementById('progress').rows[0].cells[0].childNodes[0].data="Operation Complete.";
                            dhxProgressWin.window("w1")._frame.contentWindow.document.getElementById('waitimg').src="_img/copy_complete.gif";
                        }
                    }
                    else {
                        window.clearInterval(intervalID);
                        if (dhxProgressWin.isWindow("w1")){
                            dhxProgressWin.window("w1")._frame.contentDocument.getElementById("cancel").value="Close";
                            dhxProgressWin.window("w1")._frame.contentWindow.document.getElementById('progress').rows[0].cells[0].childNodes[0].data="Operation Complete.";
                            dhxProgressWin.window("w1")._frame.contentWindow.document.getElementById('waitimg').src="_img/copy_complete.gif";
                        }
                    }
                    selid=dhxFMTree.getSelectedItemId();
                    dhxFMGrid.updateFromXML("_include/getDirContent.php?dir="+selid.replace(/&/g,"%26").replace(/\+/g,"%2B"), true, true);
                }
            }
        });
    }

    function killProcess(pid){
        window.clearInterval(intervalID);
        dhtmlxAjax.get("_include/shellExec.php?task=kill_pid&pid="+pid,
            function(loader){
            if(loader.xmlDoc.responseXML!=null) {
                var params = loader.doXPath("//param");
                error=params[0].firstChild.nodeValue;
                dhxProgressWin.window("w1").close();
            }
        });
    }

    function showProgress(header,text1,pid) {
        dhxProgressWin.setSkin(defaultSkin); 
        dhxProgressWin.setImagePath("_js/dhtmlx/imgs/");
        progresswins=dhxProgressWin.createWindow("w1",10,10,260,180);
        progresswins.setText(header);
        progresswins.center();
        progresswins.denyResize();
        progresswins.button("minmax1").hide();
        progresswins.attachURL("_include/showProgress.php?text1="+text1+"&pid="+pid);
    }

    function flipSelectedDrive(id, mode) {
        if (mode == true)
            mvalue=1;
        else
            mvalue=0;
        var loader = dhtmlxAjax.getSync("_include/shellExec.php?task=flip_drive&id="+id+"&mode="+mvalue);
        if (loader.xmlDoc.responseXML!=null) {
            var params = loader.doXPath("//param");
            file_found=params[0].firstChild.nodeValue;
            if (file_found == "no") {
                showError("Error while hide/show Drive","Error while hide/show Drive","Please report this error.","error");
            }
            else {
                dhxFMTree.selectItem(prev_treenodeId, true);
                dhxFMTree.smartRefreshItem("popcornhour", "_include/getDirTree.php");
            }
        }
    }

    function playMovie() {
        var loader = dhtmlxAjax.getSync("_include/shellExec.php?task=play_movie");
        if (loader.xmlDoc.responseXML!=null) {
            var params = loader.doXPath("//param");
            file_found=params[0].firstChild.nodeValue;
            if (file_found == "no") {
                showError("Unrar binary not found","Unrar binary not found","Make sure unrar binary exists and executable.","error");
            }
        }
    }

</script>
