<?php
// +-----------------------------------------------------------------------+
// |                                                                       |
// | THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS   |
// | "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT     |
// | LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR |
// | A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT  |
// | OWNER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, |
// | SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT      |
// | LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, |
// | DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY |
// | THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT   |
// | (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE |
// | OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.  |
// |                                                                       |
// +-----------------------------------------------------------------------+

if(is_readable("_include/config.php"))
    include "_include/config.php";
else
    include "config.php";

if(is_readable("_include/functions.php"))
    include "_include/functions.php";
else
    include "functions.php";

global $errstr;

//FUNCTION TO USE IN THE CODE LATER
global $tmpdir;
ini_set("session.save_path", $tmpdir);
session_start();
//XML HEADER

//include XML Header (as response will be in xml format)
if ( stristr($_SERVER["HTTP_ACCEPT"],"application/xhtml+xml") ) {
 		header("Content-type: application/xhtml+xml"); } else {
 		header("Content-type: text/xml");
}
echo("<?xml version=\"1.0\" encoding=\"UTF-8\"?>\n"); 
//PREPARE VALUES 

if(isset($_GET["!nativeeditor_status"]) && trim($_GET["!nativeeditor_status"])=="inserted"){
    //INSERT
    // Get values from post data
    $sno = $_GET["tr_id"];
    $name = $_GET["tr_text"];

    $newId = $_GET["tr_id"];
    $action = "insert";
} else if(isset($_GET["!nativeeditor_status"]) && $_GET["!nativeeditor_status"]=="deleted"){
    //DELETE
    $tree_id = $_GET["tr_id"];
    $tree_pid = $_GET["tr_pid"];
    $tree_text = $_GET["tr_text"];
    $tree_order = $_GET["tr_order"];

    $newId = $_GET["tr_id"];
    $action = "delete";
} else if(isset($_GET["!nativeeditor_status"]) && $_GET["!nativeeditor_status"]=="updated"){
    //DELETE
    $tree_id = $_GET["tr_id"];
    $tree_pid = $_GET["tr_pid"];
    $tree_text = $_GET["tr_text"];
    $tree_order = $_GET["tr_order"];

    $newId = $_GET["tr_id"];
    $action = "update";
} else if(isset($_GET["!nativeeditor_status"]) && $_GET["!nativeeditor_status"]=="rename"){
    //DELETE
    $tree_id = $_GET["tr_id"];
    $tree_pid = $_GET["tr_pid"];
    $tree_text = $_GET["tr_text"];
    $tree_order = $_GET["tr_order"];

    if ($tree_pid == "popcornhour") {
        SetDriveParams($tree_id, 2, $tree_text);
        $newId = $tree_id;
    } else {
        if (is_dir($tree_id))
            $new_id=dirname($tree_id).'/'.$tree_text.'/';
        else
            $new_id=dirname($tree_id).'/'.$tree_text;

        rename($tree_id, $new_id);
        $newId = $new_id;
    }
    $action = "insert";
} else {
    //DELETE
    $tree_id = $_GET["tr_id"];
    $tree_pid = $_GET["tr_pid"];
    $tree_text = $_GET["tr_text"];
    $tree_order = $_GET["tr_order"];

    $newId = $_GET["tr_id"];
    $action = "update";
}
?>
<!-- response xml -->
<data>
	<?php 
	if(strlen($newId)!=0){
		print('<action type="'.$action.'" sid="'.$_GET["tr_id"].'" tid="'.$newId.'"/>');
	}else{
		print("<action type='error'>$errstr</action>");
	}
	?>
</data>
