<?php 
// +-----------------------------------------------------------------------+
// |                                                                       |
// | THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS   |
// | "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT     |
// | LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR |
// | A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT  |
// | OWNER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, |
// | SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT      |
// | LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, |
// | DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY |
// | THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT   |
// | (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE |
// | OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.  |
// |                                                                       |
// +-----------------------------------------------------------------------+

if(is_readable("_include/config.php"))
    include "_include/config.php";
else
    include "config.php";

if(is_readable("_include/functions.php"))
    include "_include/functions.php";
else
    include "functions.php";

global $tmpdir;
ini_set("session.save_path", $tmpdir);
session_start();

if (isset($_GET["file"]))
    $file = $_GET["file"];
if ((file_exists($file))) {
   $fileArray = explode("/", $file);
   header("Pragma: public"); 
   header("Expires: 0"); 
   header("Cache-Control: must-revalidate, post-check=0, pre-check=0"); 
   header("Content-type: application/force-download");
   header("Content-Disposition: inline; filename=".$fileArray[sizeof($fileArray)-1]);
   header("Content-Transfer-Encoding: Binary");
   header("Content-length: ".File_Size($file));
   header('Content-Type: application/octet-stream');
   header("Content-Disposition: inline; filename=".$fileArray[sizeof($fileArray)-1]);
   readfile("$file");
} else {
   echo "No file selected";
} //end if

?> 
