<xsl:stylesheet version="1.0" xmlns:xsl="http://www.w3.org/1999/XSL/Transform">
	<xsl:variable name="icons_src_dir">.</xsl:variable>
	
	<xsl:template match="item">
		<div class="dhx_folders_FTILES_item">
			<!-- icon -->
			<img border='0' style="float:left;">
				<xsl:attribute name="src"><xsl:value-of select="$icons_src_dir"/><xsl:value-of select="./image"/></xsl:attribute>
				<xsl:attribute name="onerror">this.onerror = null;this.src='<xsl:value-of select="$icons_src_dir"/>/unknown.gif';</xsl:attribute>
			</img>
			<!-- label -->
			<div class="dhx_folders_FTILES_item_text" style="margin-top:10px;">
				<xsl:value-of select="./@name"/>
			</div>
			<!-- file size -->
			<div class="dhx_folders_FTILES_item_text_gray">
				<xsl:value-of select="./filesize"/>
			</div>
		</div>
	</xsl:template>
	
</xsl:stylesheet>
